#pragma rtGlobals=1		// Use modern global access method.

Function AlignByMax(Pop)			//Aligns traces in a pouplationwave to the maximum at 0

Wave Pop


Variable NumWaves, Points, ii, xval, maxval

Points = dimsize(Pop,0)
NumWaves = dimsize(Pop,1) 

if (NumWaves == 0)								//abort if no populationwave
	return -1
endif

duplicate /o pop, W_AlignedByMax
W_AlignedByMax = NaN

for(ii=0;ii<NumWaves;ii+=1)
	
	imagestats /m=1/g={0,Points-1,ii,ii} Pop		//find maxima
	if(v_flag == -1)
		DoAlert 0, "Somesthing's wrong with ImageStats"
		return -1
	endif
	
	xval = v_maxRowLoc
	maxval = points - v_maxRowLoc
	
	W_AlignedByMax[][ii] = pop[p+xval][ii]		//Align Maximum to 0
	W_AlignedByMax[maxval,points-1][ii]=NaN	//Replace empty values with NaN

endfor


end

///////////////////////


Function AlignByMaxOffset(Pop)			//Aligns traces in a pouplationwave to the maximum, at the position of the leftmost maximum

Wave Pop


Variable NumWaves, Points, ii, xval, maxval, minval

Points = dimsize(Pop,0)
NumWaves = dimsize(Pop,1) 

if (NumWaves == 0)								//abort if no populationwave
	return -1
endif

make /o/n=(NumWaves) calc_maxima = NaN
duplicate /o pop, W_AlignedByMax
W_AlignedByMax = NaN

for(ii=0;ii<NumWaves;ii+=1)
	
	imagestats /m=1/g={0,Points-1,ii,ii} Pop		//find maxima
	if(v_flag == -1)
		DoAlert 0, "Somesthing's wrong with ImageStats"
		return -1
	endif
	
	calc_maxima[ii] = v_maxRowLoc

endfor

wavestats /m=1/q calc_maxima
minval = v_min

print minval

for(ii=0;ii<NumWaves;ii+=1)
	

	
	xval = calc_maxima[ii]
	maxval = points - xval + minval
	
	W_AlignedByMax[][ii] = pop[p+xval-minval][ii]		//Align Maximum to 0
	W_AlignedByMax[maxval,points-1][ii]=NaN	//Replace empty values with NaN

endfor






//Killwaves /z  calc_maxima

end