#pragma rtGlobals=1		// Use modern global access method.

function thr(imagewave, threshold)

wave imagewave
variable threshold

duplicate /o imagewave, thr_result

 thr_result = SelectNumber( thr_result [p][q]<threshold, thr_result [p][q],1)
 thr_result = SelectNumber( thr_result [p][q]>=threshold, thr_result [p][q],0) //0 ROI pixels

end



/////////////////

function contours(imgwave)

wave imgwave

variable imgx = dimsize(imgwave, 0), imgy = dimsize(imgwave,1), cx, cy, index=0, condition

make /o /n=1 topx,topy, bottomx, bottomy//, right_x, right_y, left_x, left_y
//setscale /p x, 0, dimdelta(imgwave,0), waveunits(imgwave,0) topx, right_x, left_x, bottomx
//setscale /p x, 0, dimdelta(imgwave,1), waveunits(imgwave,1) topy, right_y, left_y, bottomy


imagestats imgwave

cx=0
do		//top
cy=imgy-1
condition = 1
	do
		if(imgwave[cx][cy]>v_sdev)			//0 ROI pixels
			topx[index]={cx}
			topy[index]={cy}
			index +=1
			cx+=1
			condition = 0
		endif
		cy -=1
		if (cy < 0)
			condition = 0
		endif
	while (condition)
	
	cx +=1
while(cx < imgx)

index=0
cx=0
do		//bottom
cy=0
condition = 1
	do
		if(imgwave[cx][cy]<-v_sdev)			//0 ROI pixels
			bottomx[index]={cx}
			bottomy[index]={cy}
			index +=1
			cx+=1
			condition = 0
		endif
		cy +=1
		if (cy >= imgy)
			condition = 0
		endif
	while (condition)
	
	cx +=1
while(cx < imgx)



topx = topx*(dimdelta(imgwave, 0))//+dimoffset(imgwave,0)
topy = topy*(dimdelta(imgwave, 1))//+dimoffset(imgwave,1)

bottomx = bottomx*(dimdelta(imgwave, 0))//+dimoffset(imgwave,0)
bottomy= bottomy*(dimdelta(imgwave, 1))//+dimoffset(imgwave,1)

end

//////////////////

function FindOrientation(img, term)

wave img
variable term

variable i
make /n=8 /o results
setscale /p x, 0,term, " Rotation" results
//wave fo_x, fo_y

for(i=0;i<180/term;i+=1)

	imagerotate /a=(i*term) /q /s /e=(NaN) img
	differentiate /dim=0 m_rotatedimage /d=dif_x
	imagestats dif_x
	results[i]={v_sdev}
endfor



wavestats /q /m=1 results
killwaves /z m_rotatedimage,dif_x, results

return v_minloc


end

////////////////////////

function HemiCircle (w,x) : FitFunc
		Wave w
	Variable x

	//CurveFitDialog/ These comments were created by the Curve Fitting dialog. Altering them will
	//CurveFitDialog/ make the function less convenient to work with in the Curve Fitting dialog.
	//CurveFitDialog/ Equation:
	//CurveFitDialog/ f(x) = CenterY-Direction*sqrt((x-CenterX)^2+Radius^2)
	//CurveFitDialog/ End of Equation
	//CurveFitDialog/ Independent Variables 1
	//CurveFitDialog/ x
	//CurveFitDialog/ Coefficients 4
	//CurveFitDialog/ w[0] = CenterX
	//CurveFitDialog/ w[1] = CenterY
	//CurveFitDialog/ w[2] = Radius
	//CurveFitDialog/ w[3] = Direction
	
	variable result
	
	if (w[3]>=0)
		result = w[1]+sqrt((x-w[0])^2+w[2]^2)
	else
		result = w[1]-sqrt((x-w[0])^2+w[2]^2)
	endif

	return  result
End
	
end

///////////////////

function HemiEllipse (w,x) : FitFunc
		Wave w
	Variable x

	//CurveFitDialog/ These comments were created by the Curve Fitting dialog. Altering them will
	//CurveFitDialog/ make the function less convenient to work with in the Curve Fitting dialog.
	//CurveFitDialog/ Equation:
	//CurveFitDialog/ f(x) =Radius2+sqrt(CanterY+CenterY*(x-Radius1)^2/Centerx^2)
	//CurveFitDialog/ End of Equation
	//CurveFitDialog/ Independent Variables 1
	//CurveFitDialog/ x
	//CurveFitDialog/ Coefficients 5
	//CurveFitDialog/ w[0] = CenterX
	//CurveFitDialog/ w[1] = CenterY
	//CurveFitDialog/ w[2] = Radius1
	//CurveFitDialog/ w[3] = Radius2
	//CurveFitDialog/ w[4] = Direction
	
	variable result
	
	if (w[4]>=0)
		result = w[3]+sqrt(w[1]^2+w[1]^2*((x-w[2])^2/w[0]^2))
	else
		result = w[3]-sqrt(w[1]^2+w[1]^2*((x-w[2])^2/w[0]^2))
	endif

	return  result
End
	
end