#pragma rtGlobals=1		// Use modern global access method.

//make wv={0,1,4,5 ,12,17,33}


Function drawStim(popwave,coef,sv)
wave popwave, coef
variable sv

if(!waveexists(stim))

make /o/n=(70,2) stim = 0
setscale /p x,0,1, "s" stim
setscale /p y,0,1, "mW/m\S2" stim
stim[10,19][0]=1 //amber
stim[50,59][0]=1 //amber
stim[50,59][1]=1 //blue
stim[30,39][1]=1 //blue

endif

variable n, index; string name

for(n=0; n<numpnts(coef); n+=1)
index=coef[n]

name="Trace "+num2str(index)
display /r stim[][0] as name; delayupdate
appendtograph /r stim[][1]; delayupdate
Label right "Light intensity\rmW/m\\S2\r"; delayupdate
ModifyGraph lsize=3,rgb(stim)=(65535,43690,0),rgb(stim#1)=(0,0,65535); delayupdate
ModifyGraph lstyle(stim#1)=1; delayupdate
ModifyGraph mode=6; delayupdate
modifygraph height = 75,  width=200; delayupdate
appendtograph popwave[][index]; delayupdate
ModifyGraph rgb($nameofwave(popwave))=(0,0,0); delayupdate
label left "F/F"; delayupdate
setaxis left -1, 2; delayupdate
setaxis right 0,60

if(sv)
	string fn = nameofwave(popwave)
	fn = fn[0,8]+"_"+num2str(index)
	savepict /z/e=-2 as fn
endif

endfor

end


Function drawTrain(popwave,coef,sv)
wave popwave, coef
variable sv

if(!waveexists(train))

make /o/n=(70,2) train = 0
setscale /p x,0,1, "s" train
setscale /p y,0,1, "mW/m\S2" train
train[10,19][0]=mod(p+1,2) //amber
train[50,59][0]=mod(p+1,2) //amber
train[50,59][1]=mod(p+1,2) //blue
train[30,39][1]=mod(p+1,2) //blue

endif

variable n, index; string name

for(n=0; n<numpnts(coef); n+=1)
index=coef[n]

name="Trace "+num2str(index)
display /r train[][0] as name; delayupdate
appendtograph /r train[][1]; delayupdate
Label right "Light intensity\rmW/m\\S2\r"; delayupdate
ModifyGraph lsize=1,rgb(train)=(65535,43690,0),rgb(train#1)=(0,0,65535); delayupdate
ModifyGraph lstyle(train#1)=1; delayupdate
ModifyGraph mode=6; delayupdate
modifygraph height = 75,  width=200; delayupdate
appendtograph popwave[][index]; delayupdate
label left "F/F"; delayupdate
ModifyGraph rgb($nameofwave(popwave))=(0,0,0); delayupdate
setaxis left -1, 2; delayupdate
setaxis right 0,60
if(sv)
	string fn = nameofwave(popwave)
	fn = fn[0,8]+"_"+num2str(index)
	savepict /z/e=-2 as fn
endif

endfor

end