#pragma rtGlobals=1		// Use modern global access method.
#pragma version=1			//Save attributes as HDF5 format
#include "ExpDataBase"


Function ExpDBCP()

	if(exists("HDF5CreateFile")!=4)
		DoAlert 0, "HDF5 XOP was not detected. Please install by placing an alias from More Extensions>File Loaders>HDF5.xop into the Igor Extensions folder."
		return -1
	endif

	DFREF saveDFR = GetDataFolderDFR()		//save current data folder
	string Information = IgorInfo(0), infolist, infolist2
	variable screenright, screenbottom
	
	infolist = StringFromList(4,information,";")
	infolist2 = StringFromList(3,infolist,",")
	screenright = Str2Num(infolist2)
	
	variable width=880
	variable height=505
	variable left=round(screenright-width)/2, top = 0
	variable right=left+width
	variable bottom = top + height
	
	
	if(WinType("EDBCP"))
		DoWindow /F EDBCP
	else
	//Initialise Folders/////////////////////////////////////////////////////////
		If(DataFolderRefStatus(root:Packages)!=1)
			NewDataFolder root:Packages
			NewDataFolder root:Packages:EDBCP
			SetDataFolder root:Packages:EDBCP
		ElseIf(DataFolderRefStatus(root:Packages)==1 && DataFolderRefStatus(root:Packages:EDBCP)!=1)
			NewDataFolder root:Packages:EDBCP
		ElseIf( DataFolderRefStatus(root:Packages:EDBCP)==1)
			//That's just fine
		Else
			DoAlert 0, "EDBCP_Initialise failed due to conflict with a free data folder."
			return -1
		EndIf
		
		DFREF WF = root:Packages:EDBCP
		
		
	//Set Global variables/////////////////////////////////////////////////
		SetDataFolder WF
			variable /g g_FileID, g_LAFCheck=0, g_AtrribRefWaveExists=0, g_overwrite
			string /g g_CurrentHDF5File="_none_", g_CurrentFolder="root:", g_HDF5pathName, g_FullPath = "_none_", g_AttribType = "EBD_Attrib"
			string /g g_highlighted="_none_"
			Make/o/t TitleWave = {"\f01\JCData Folders"}
			Make/o/t ContentsTitleWave = {"\f01\JCContents"}, HDF5ContentsTitle={{"\f01Group"},{"\f01Contents"}}
			Make /o/t WavesList, FolderList, W_FromFile, WavesListDisplay, HDF5ContentsList={{""},{""}}
			
			MakeFolderListWave("root:", 1,FolderList)
			MakeFolderListWave("root:", 2,WavesList)
			MakeFolderListWave("root:", 3,WavesListDisplay)
			
			
		SetDataFolder SaveDFR
			SVAR CurrentFile = WF:g_currentHDF5File, currentfolder=WF:g_currentfolder, FullPath=WF:g_FullPath , AttribType=WF:g_AttribType
			NVAR LAFCheck=WF:g_LAFCheck, overwrite=WF:g_overwrite
			
		
		
		//Make Panel/////////////////////////////////////////////////////////
		NewPanel /K=2 /N=EDBCP /W=(left,top,right,bottom) as "DataBase Manager"
		
		GroupBox TopButtons pos = {5,5},size={width-10,50},win=EDBCP
		GroupBox Lists pos = {5,65},size={450,height-75},win=EDBCP
		GroupBox Buttons pos={465,65},size={width-470,height-110}, win=EDBCP
		
		TitleBox HDF5File, pos = {240, 20},size={width-260,20},win=EDBCP,fsize=10,title="Current HDF5 file",variable=FullPath, fixedSize=1
		TitleBox AttribTitle, pos = {475,80}, size={width-495,20},win=EDBCP,fsize=10,variable=AttribType, fixedSize=1
		
		Button NewHDF5, pos = {20, 20}, size = {80,20}, title="New HDF5",win=EDBCP, proc = EDBCP_BC
		Button ChooseHDF5, pos = {120, 20}, size = {100,20}, title="Choose HDF5",win=EDBCP, proc = EDBCP_BC
		Button QuitEDBCP, pos= {width-100,height-35}, size = {80,20}, title="Quit", fcolor=(100,10,00),win=EDBCP, proc = EDBCP_BC
		Button MAW, pos={270,height-50}, size={120,20}, title="Create Attributes", win=EDBCP, proc = EDBCP_BC
		Button ChangeAttrib, pos={475,110},size={160,20}, title="Change Attribute Type",win=EDBCP, proc= EDBCP_BC
		Button NewFolder,pos={20,height-50},size={80,20}, title="New",win=EDBCP, proc= EDBCP_BC
		Button KillFolder,pos={120,height-50},size={80,20}, title="Kill",win=EDBCP, proc= EDBCP_BC
		Button Load, pos={480,height-35},size={160,20}, title="Load Data by Attribute",win=EDBCP, proc= EDBCP_BC
		
		CheckBox LoadAttribFile, pos={475,140},title="Attributes from file?",win=EDBCP,variable=LAFCheck, proc=EDBCP_CBC
		CheckBox OverwriteFolders, pos={475,160},title="Overwrite Folders in HDF5?",win=EDBCP,variable=overwrite, noproc

		ListBox FolderLB, pos = {20,80},size={200,Height-140},editstyle=0, listwave=WF:FolderList,mode=1,win=EDBCP,TitleWave=WF:TitleWave,win=EDBCP,proc= EDBCPListboxProc
		ListBox ContentsLB, pos = {240,80},size={200,Height-140}, listwave=WF:WavesListDisplay,mode=0,win=EDBCP,win=EDBCP,proc= EDBCPListboxProc,TitleWave=WF:ContentsTitleWave
		ListBox HDF5LB, pos={480,185},size={Width-500,Height-240},listwave=WF:HDF5ContentsList,mode=0,win=EDBCP,win=EDBCP,proc= EDBCPListboxProc,TitleWave=WF:HDF5ContentsTitle,widths={round((width-500)/4),round((width-500)*.7)},usercolumnresize=1
		
	endif

End




////////////////////////////////
Static Function MakeFolderListWave(FolderSTR, mode,target)
	String FolderStr
	variable  mode		//1 lists folders, 2 lists contents, 3 lists contents & colourises; other numbers won't work
	wave /t target
	
	variable ii, NumFolders, pointPos
	string DFDir, Folders, SubFolders, CurrentFolder, CheckFolder, targetname, wNote, wName
	
	DFREF SaveDFR = GetDataFolderDFR(), Folder
	
	if(stringmatch(FolderStr[0,4],"root:"))
		CheckFolder = FolderStr
		Folder = $CheckFolder
	else
		CheckFolder="root:"+FolderStr
		Folder  = $CheckFolder
	endif
	
	
	SetDataFolder folder
	
	
	
	if(mode==1)
		DFDir=DataFolderDir(1)
		Folders=StringByKey("FOLDERS",DFDir,":")
		Folders=ReplaceString(",",Folders,";")
		Folders=SortList(Folders,";",16)
		Folders="\;..;"+Folders
	elseif(mode>1)
		DFDir=DataFolderDir(2)
		Folders=StringByKey("WAVES",DFDir,":")
		Folders=ReplaceString(",",Folders,";")
		Folders=SortList(Folders,";",16)
	else
		return 0
	endif
	
	
	Variable Items = ItemsInList(Folders)
	Make/t/free/n=(Items) Flist
	For(ii=0;ii<Items;ii+=1)
		if(mode==3)
			wName=StringFromList(ii,Folders)
			wNote=Note($wName)
		
			pointpos=strsearch(WNote,"\r",0)
				if(pointpos==-1)		//one-liner
					pointpos=strlen(WNote)
				endif
			WNote=WNote[0,pointpos-1]	//first line of wavenote
			if(stringMatch(wNote,"EDB_Attributes"))
				Flist[ii]="\f01\K(65535,0,0)"+StringFromList(ii,Folders)		//make name of attributes wave bold & red
			else
				Flist[ii]=StringFromList(ii,Folders)
			endif
		else
			Flist[ii]=StringFromList(ii,Folders)
		endif
	EndFor
	
	
	SetDataFolder SaveDFR	
	
	redimension /n=(Items) target
	
	 target=flist
	 return 1
End

////////////////////////////////////////////////////////////////////////

Static Function MakeHDF5ContentsList()

	DFREF WF = root:Packages:EDBCP
	DFREF SaveDFR = GetDataFolderDFR()
	Wave /t ListWv = WF:HDF5ContentsList
	SVAR CurrentFile = WF:g_currentHDF5File, HDF5folder=WF:g_HDF5pathName
	
	ListWv={{""},{""}}
	
	variable nItems, ii, nFolders,jj, count=0
	string ItemList, buffer

	if(stringmatch(currentfile,"_none_"))
		return 0
	endif
	
	SetDataFolder WF
	HDF5GetAttrib(HDF5Folder,CurrentFile)
	wave/t/z AttWv=WF:GA_GroupList
	SetDataFolder SaveDFR
	
	
	nFolders=DimSize(AttWv,0)
	
	for(jj=0;jj<nFolders;jj+=1)
		buffer=AttWv[jj][0]
		ListWv[count][0]={{buffer[1,strlen(buffer)-1]},{""}}
		count+=1
		ItemList=AttWv[jj][1]
		nItems=ItemsInList(ItemList)
		for(ii=0;ii<nItems;ii+=1)
			ListWv[count][0]={{""},{StringFromList(ii,ItemList)}}
			Count+=1
		endfor
	endfor
	
End





////////////////////////////ListBoxControl////////////////////////////////
Function EDBCPListboxProc(ctrlName,row,col,event) : ListboxControl
	String ctrlName     // name of this control
	Variable row        // row if click in interior, -1 if click in title
	Variable col        // column number
	Variable event      // event code
	//	-1	control being killed.
	//	1		mouse down.
	//	2		mouse up.
	//	3		double click.
	//	4		cell selection (mouse or arrow keys).
	//	5		cell selection plus Shift key.
	//	6		begin edit.
	//	7		finish edit.
	//	8		Vertical scroll. See Scroll Event Warnings below.
	//	9		Horizontal scroll by user or by the hScroll=h  keyword.
	//	10	Top row set by row=r  or first column set by col=c  keywords.
	//	11	Column divider resized.
	//	12	Keystroke, character code is place in row field.

	DFREF WF = root:Packages:EDBCP, SelectedFolder
	DFREF saveDFR = GetDataFolderDFR()		//save current data folder
	SVAR currentfolder=WF:g_currentfolder, AttribType=WF:g_AttribType
	SVAR currentFile=WF:g_CurrentHDF5File, PathName =WF:g_HDF5pathName
	SVAR highlighted=WF:g_highlighted
	NVAR overwrite=WF:g_overwrite
	wave/t flw=WF:FolderList
	wave/t wlw=WF:WavesList, WLD=WF:WavesListDisplay
	Wave /t Title=WF:TitleWave
	
	DFREF currentFolderDFR=$currentFolder
	
	string FileName, WaveNote, AlertMessage, GroupName
	
	variable pointpos
	
	if(event==3)	//DoubleClick
	
		StrSwitch(ctrlName)
/////////////////////////////////FolderLB
			case "FolderLB":
			
							
				if(row==0)				//root
					currentfolder="root:"
				elseif(row==1)				//up one
					PointPos=StrSearch(currentfolder,":",inf,1)
					currentfolder=currentfolder[0,PointPos-1]
					PointPos=StrSearch(currentfolder,":",inf,1)
					currentfolder=currentfolder[0,PointPos]
					
				elseif(row < numpnts(flw))
				
					currentfolder += Flw[row]+":"
				endif
				
				If(stringMatch(currentFolder,""))	//up too far?
					currentfolder="root:"
				EndIf
				
				
					Title[0]="\f01"+CurrentFolder
					MakeFolderListWave(currentfolder, 1,FLW)	//Folders
					MakeFolderListWave(currentfolder, 2,WLW)	//Contents (waves)
					MakeFolderListWave(currentfolder, 3,WLD)	//Contents (waves) in colour
							
					ListBox FolderLB, listwave=FLW, TitleWave=Title
					ListBox ContentsLB, listwave=WLD
		
			break
/////////////////////////////////ContentsLB			
			Case "ContentsLB":
				FileName = WLW[row]
				SelectedFolder = $currentFolder
				SetDataFolder SelectedFolder
				
				WaveNote=note($FileName)
				pointpos=strsearch(WaveNote,"\r",0)
				if(pointpos==-1)		//one-liner
					pointpos=strlen(WaveNote)
				endif
				WaveNote=WaveNote[0,pointpos-1]	//first line of wavenote
				if(stringmatch(WaveNote,"EDB_Attributes"))
					AlertMessage= "Do you want to save items in <"+currentFolder +">?\rClicking \"no\" will edit <"+Filename+">."
					DoAlert 2, AlertMessage
					if(v_flag==1)		//yes
												
						if(StringMatch(CurrentFile,"_none_"))
							DoAlert 0, "Please open or create a HDF5 file first."
							break
						else
							if(stringmatch(currentfolder,"root:"))
								Prompt GroupName, "Enter a name for the Group"
								DoPrompt/Help="If you don't enter a name, your group would be named \"root:\". Guess what will happen if you save another group!" "A name for the group must be entered", GroupName
								if(v_flag==1)
									break
								endif
								if(stringmatch(GroupName, ""))
									DoAlert 0, "You really must enter a name for the group."
									break
								else
									SetDataFolder currentFolderDFR
									HDF5SaveWithAttrib($FileName,AttribType,PathName,Currentfile,overwrite=overwrite,groupname=GroupName)	
									SetDataFolder SaveDFR
								endif
									
							else
								SetDataFolder currentFolderDFR
								HDF5SaveWithAttrib($FileName,AttribType,PathName,Currentfile,overwrite=overwrite)	
								SetDataFolder SaveDFR
							endif
						 MakeHDF5ContentsList()
						endif
						
						
					elseif(v_flag==2)	//no
						edit /k=1 $filename
					else					//maybe
						return 0
					endif
					
					
					
				Else			
					edit /k=1 $filename
				endif
				SetDataFolder SaveDFR				
			break
/////////////////////////////////HDF5LB			
			Case "HDF5LB":
			
			
			break
			
			default:
				DoAlert 0, "Undefinded Control in EDBCPListBoxProc"
			break
		EndSwitch
	
	Endif

	if(event==4)		//highlighted
		StrSwitch(ctrlName)
			case "FolderLB":
				if(row==dimsize(flw,0) || row < 2)
					highlighted="_none_"
				else
					highlighted=fLW[row]
				endif	
			break
			
			
		default:
		
		endswitch
	
	
	
	endif





	return 0            // other return values reserved
End



////////////////////////////ButtonControl////////////////////////////////

Function EDBCP_BC (ctrlName) : ButtonControl
	String ctrlName
	
	DFREF WF = root:Packages:EDBCP
	DFREF saveDFR = GetDataFolderDFR()		//save current data folder
	
	
	NVAR fileID = WF:g_fileID, LAFCheck=WF:g_LAFCheck, ARWExists=WF:g_AtrribRefWaveExists
	SVAR currentFile=WF:g_CurrentHDF5File, PathName =WF:g_HDF5pathName, FullPath=WF:g_fullPath, currentFolder=WF:g_currentFolder
	SVAR AttribType=WF:g_AttribType, highlighted=WF:g_highlighted
	wave/t WLW=WF:WavesList, AttribRefFile=WF:W_FromFile
	wave/t flw=WF:FolderList
	wave/t wlw=WF:WavesList, WLD=WF:WavesListDisplay
	
	DFREF currentFolderDFR = $currentFolder
	
	String resultName, AttribPromptStr = AttribType, NewFolderName
	variable pointpos, check
	
	StrSwitch (ctrlName)
	Case "QuitEDBCP":
		
		if(WinType("EDBCP"))			//Kill Window
			KillWindow EDBCP
		endif
			
		if(DataFolderRefStatus(WF))	//Clean Folders
			KillDataFolder/z WF	
			//SetDataFolder root:Packages
			Variable ObjectCount=CountObjects("root:packages",1)+CountObjects("root:packages",2)+CountObjects("root:packages",3)+CountObjects("root:packages",4)
			if(ObjectCount==0)
				KillDataFolder root:packages
			endif	
			
			SetDataFolder saveDFR
		endif
	Break
	
	
	Case "ChooseHDF5":
		HDF5OpenFile /I fileID as ""
		If(v_flag==0)
			PathName=s_path
			currentFile=s_fileName
			HDF5CloseFile fileID
			FullPath = MakeFullPath(PathName,currentfile,80)			
		 	MakeHDF5ContentsList()	
		EndIf		
	break
	
	Case "NewHDF5":
		HDF5CreateFile /I/o fileID as ""
		If(v_flag==0)
			PathName=s_path
			currentFile=s_fileName
			HDF5CloseFile fileID
			FullPath = MakeFullPath(PathName,currentfile,60)		
			MakeHDF5ContentsList()			
		EndIf			
	break
	
	Case "MAW":
		
		MakeAttribWaveInFolder(currentFolder, "Attributes")
		wave/z/t AttribWave = currentFolderDFR:Attributes
		check=MakeFolderListWave(currentfolder, 2,WLW)	//update Contents (waves)
		if(LAFCheck && ARWExists && check)	//attributes from file
		

			 SetAttributesFromFile(AttribWave, AttribRefFile)
		endif
		MakeFolderListWave(currentfolder, 1,FLW)	//Folders
		MakeFolderListWave(currentfolder, 2,WLW)	//Contents (waves)
		MakeFolderListWave(currentfolder, 3,WLD)	//Contents (waves) in colour		
	break
	
	Case "ChangeAttrib":
		Prompt AttribPromptStr, "Name of the Attributes"
		DoPrompt /help="" "Edit parameters", AttribPromptStr
		if(v_flag==0)
			AttribType = AttribPromptStr
		endif
	
	break
	
	Case "NewFolder":
		Prompt NewFolderName, "Name of the Attributes"
		DoPrompt /help="" "Edit parameters", NewFolderName
		if(v_flag==1)
			break
		endif
		SetDataFolder currentFolderDFR
		NewDataFolder $NewFolderName
		MakeFolderListWave(currentfolder, 1,FLW)	//Folders
		MakeFolderListWave(currentfolder, 2,WLW)	//Contents (waves)
		MakeFolderListWave(currentfolder, 3,WLD)	//Contents (waves) in colour
		
		SetDataFolder saveDFR	
	break
	
	Case "KillFolder":
	
		if(stringmatch(highlighted,"_none_"))
			break
		elseif(stringmatch(highlighted,"root:") || stringmatch(highlighted,"Packages")||stringmatch(highlighted,"EDBCP"))	//no suicide allowed
			DoAlert 0, "Can't kill <"+highlighted+"> from here."
		else
			DoAlert 1, "Delete <"+highlighted+"> and all its contents? (No Undo)"
			if(v_flag==1)
				SetDataFolder currentFolderDFR
				KillDataFolder $highlighted
				SetDataFolder saveDFR	
				MakeFolderListWave(currentfolder, 1,FLW)	//Folders
				MakeFolderListWave(currentfolder, 2,WLW)	//Contents (waves)
				MakeFolderListWave(currentfolder, 3,WLD)	//Contents (waves) in colour
			else
				break
			endif
		endif
	
	break
	
	Case "Load":
		if(StringMatch(CurrentFile,"_none_"))
				DoAlert 0, "Please open or create a HDF5 file first."
				break
		else
			LoadDataByAttributes()
			MakeFolderListWave(currentfolder, 1,FLW)	//Folders
			MakeFolderListWave(currentfolder, 2,WLW)	//Contents (waves)
			MakeFolderListWave(currentfolder, 3,WLD)	//Contents (waves) in colour
		endif
	break
	
	
	default:
		print ctrlname
	break
	
	
	
	EndSwitch
	
	
	
End

////////////////////////////CheckBoxControl//////////////////////////////////
Function EDBCP_CBC(name,value)
	String name
	Variable value
	
	DFREF WF = root:Packages:EDBCP
	DFREF saveDFR = GetDataFolderDFR()		//save current data folder
	
	NVAR LAFCheck=WF:g_LAFCheck,  LAFSelected=WF: g_AtrribRefWaveExists
	Variable FileRefID, pointpos, len, lines
	
	String PathName, FileNameStr = ""
	
	StrSwitch(name)
	 case "LoadAttribFile":
	 		if(value)
	 			open /d/r  FileRefID as  ""
	 				if(stringMatch(S_FileName,""))
	 					return -1
	 				endif
	 			PathName=S_FileName
	 			pointpos=StrSearch(PathName,":",inf,1)
	 			len=strlen(PathName)
	 			PathName=S_FileName[0,pointpos]
	 			FileNameStr=S_FileName[pointpos+1,len-1]
	 			
	 			SetDataFolder WF
	 			lines=GetAttributesFromFile(PathName,FileNameStr)
	 			SetDataFolder saveDFR
	 			if(lines)
	 				LAFSelected=1
	 			endif 				
	 		endif
	 
	 break
	 
	
	default:
		print name
	endswitch
	
End



////////////////////////////////////////

Static Function /s MakeFullPath(path,filename,len)
	string path, filename
	variable len

	variable pl=strlen(path)
	variable fnl=strlen(filename)
	variable total=pl+fnl, dif
	string result = path+"\f01"+filename
	
	if(total>len)				//try to preserve filename
		dif=total-len+3			//shorten by dif
		result = "..."+path[dif,pl-1]+"\f01"+filename
	endif
	
	total=strlen(result)
	if(total>len-4)			//still too long?
		dif=total-len-1
		result="..."+result[dif,total-1]
	endif
	
	return result
End





////////////////////////////////////////

Static Function/t LoadDataByAttributes()

	DFREF WF = root:Packages:EDBCP
	SVAR FileNameStr = WF:g_currentHDF5File, PathName=WF:g_HDF5pathName, Attrib=WF:g_AttribType, currentfolder=WF:g_currentfolder
	
	
	DFREF saveDFR = GetDataFolderDFR()		//save current data folder
	DFREF CurrentFolderRef = $currentfolder	//currently selected folder in the control panel
	
	
	String WhichAttrib, AttribListStr, RetStr

	SetDataFolder WF
	HDF5GetAttrib(PathName,fileNameStr)
	Wave/t GroupList=WF:GA_GroupList
	HDF5LoadAttrib(PathName,fileNameStr,Attrib, GroupList)
	Wave/t AttribList=WF:GA_Attributes
	SetDataFolder SaveDFR
	
	AttribListStr=MakeAttribListStr(AttribList)
	print attribliststr+"."

	Prompt Whichattrib, "Attribute",popup,AttribListStr
	DoPrompt/help="" "Specify attribute" WhichAttrib

	if(v_flag==1)
		return ""
	endif

	SetDataFolder CurrentFolderRef
	RetStr=HDF5LoadDataByAttrib(PathName,fileNameStr,WhichAttrib, AttribList)
	
	SetDataFolder SaveDFR
	Return RetStr
End