#pragma rtGlobals=1		// Use modern global access method.

Function GetLightThr(popwave,numbers)
wave popwave, numbers

make /o /n=(numpnts(numbers),2,8) GLTresult
duplicate /o numbers, baselines
redimension /n=(-1,2) baselines

variable  ii,jj

for(ii=0;ii<numpnts(numbers);ii+=1)

	imagestats /m=1 /gs={5,9,numbers[ii],numbers[ii]} popwave
	if(v_flag!=0)
		DoAlert 0, "Wrong params in imagestat"
		killwaves /z baselines
		return -1
	endif
	baselines[ii][0]=v_avg
	
	imagestats /m=1 /gs={30,34,numbers[ii],numbers[ii]} popwave
	if(v_flag!=0)
		DoAlert 0, "Wrong params in imagestat"
		killwaves /z baselines
		return -1
	endif
	baselines[ii][1]=v_avg

endfor

for(ii=0;ii<numpnts(numbers);ii+=1)
	for(jj=0;jj<8;jj+=1)

		imagestats /m=1 /gs={10+2*jj,12+2*jj,numbers[ii],numbers[ii]} popwave
		if(v_flag!=0)
			DoAlert 0, "Wrong params in imagestat"
			killwaves /z baselines
		return -1
		endif
		GLTresult[ii][0][jj]=v_max-baselines[ii][0]
		
		imagestats /m=1 /gs={37+2*jj,39+2*jj,numbers[ii],numbers[ii]} popwave
		if(v_flag!=0)
			DoAlert 0, "Wrong params in imagestat"
			killwaves /z baselines
		return -1
		endif
		GLTresult[ii][1][jj]=v_max-baselines[ii][1]

	endfor
endfor

string popname=nameofwave(popwave)


killwaves /z baselines
end

//////////////////////////
//enter calibrated values!

function MakeTrain(ND)
variable ND

make/o/n=(64,2) train = 0
setscale/p x,0,1,"s" train
setscale/p y,0,1,"W/m\S2" train



if(ND)

	train[10][0]=0
	train[12][0]=.0
	train[14][0]=.125
	train[16][0]=.25
	train[18][0]=.5
	train[20][0]=1.6
	train[22][0]=2.1
	train[24][0]=0
	
	train[35][1]=0
	train[37][1]=0
	train[39][1]=.1
	train[41][1]=.2
	train[43][1]=.5
	train[45][1]=1
	train[47][1]=1.5
	train[49][1]=2.1
	make/o stimulus={0,.06,.125,.25,.5,1.1,1.6,2.1}
else
	train[10][0]=.0
	train[12][0]=.25
	train[14][0]=.5
	train[16][0]=1.1
	train[18][0]=2.1
	train[20][0]=6.1
	train[22][0]=8.1
	train[24][0]=0
	
	train[35][1]=0
	train[37][1]=.2
	train[39][1]=.4
	train[41][1]=1.1
	train[43][1]=2.1
	train[45][1]=4.1
	train[47][1]=6.1
	train[49][1]=8.0
	make /o stimulus={0,.2,.5,1.1,2.1,4.1,6.1,8}
endif

train/=4.9*pi
stimulus/=4.9*pi
end


///////////////////////

Function Binding(w,x):FitFunc
Wave w
variable x

	//CurveFitDialog/ These comments were created by the Curve Fitting dialog. Altering them will
	//CurveFitDialog/ make the function less convenient to work with in the Curve Fitting dialog.
	//CurveFitDialog/ Equation:
	//CurveFitDialog/ f(x) = (a*b*x)/(a+b*x)
	//CurveFitDialog/ End of Equation
	//CurveFitDialog/ Independent Variables 1
	//CurveFitDialog/ x
	//CurveFitDialog/ Coefficients 2
	//CurveFitDialog/ w[0] = a
	//CurveFitDialog/ w[1] = b
	

return (w[0]*w[1]*x)/(w[0]+w[1]*x)
end

//////////////////////////

Function GLTPopUp()

string popwave, numbers = "numbers", savename
variable sav=1

prompt PopWave, "Populationwave",popup,WaveList("*nor",";","")
prompt numbers, "Category List", popup,WaveList("*",";","")
prompt sav, "Save 0/1?"

Doprompt "Specify Waves", PopWave, numbers, sav

if(v_flag)
	return -1
endif

if(!waveexists($numbers))
	Doalert 0, "Wave "+numbers+" doesn't exist"
	return -1
endif

GetLightThr($popwave,$numbers)
wave gltresult

string popname=popwave[0,8]+"_glt"
duplicate /o gltresult, $popname

if(sav)
	savename=popwave[0,8]+"_glt"
	save /c $popname as savename
endif

killwaves/z gltresult

end