#pragma rtGlobals=1		// Use modern global access method.
#include "EqualizeScaling"
#include  "Populationwave"

function GetResponseType(wv,start,stop, thresh)
wave wv
variable start, stop, thresh

variable count=0
make /o/n=( dimsize(wv,0)) allavg


setscale /p x,dimoffset(wv,0),dimdelta(wv,0),waveunits(wv,0), allavg
setscale /p y,0,1,"F/F", allavg

do
	imagestats /m=2/g={count,count,0,(dimsize(wv,1)-1)} wv
		if (v_flag <0)
			print "error1:", count
			return -1
		endif
	allavg[count]=v_avg
	count +=1
while (count < dimsize(wv,0))

wavestats /q /r=(0,start) allavg
variable baselineav = v_avg, baselinesd = v_sdev

baselinesd = thresh	//use threshold

count = 0

duplicate /o allavg, onr,offr,nor
variable oncount=0,offcount=0,nocount=0 
onr = 0; offr = 0; nor = 0;

make /o /n=(dimsize (wv,1)) ResponseType	//0...no, 1...on, 2...off

do
	imagestats /m=2/g={start,stop,count,count} wv
		if (v_flag <0)
			print "error2:", count
			return -1
		endif
	if (v_avg > (baselineav + baselinesd))
		onr += wv[p][count]
		ResponseType[count]=1
		oncount +=1
	elseif (v_avg < (baselineav - baselinesd))
		offr += wv[p][count]
		ResponseType[count]=2
		offcount +=1
	else
		nor	+= wv[p][count]
		nocount +=1
		ResponseType[count]=0
	endif
	
count +=1		
while (count < dimsize(wv,1))

onr/=oncount
offr/=offcount
nor/=nocount

print "On:", oncount, "off:",offcount, "no response:",nocount 

end

/////////////////////////////////////////////

function GetFrequencyresponse(wv)

wave wv
duplicate wv, cw
redimension /n=(-1,0) cw

variable counter

for(counter =0;counter<dimsize(wv,1);counter +=1)

	cw=wv[p][counter]

	FFT/OUT=3/DEST=$("fft_cw"+num2str(counter)) cw;DelayUpdate

endfor

populationwave("fft_cw", nameofwave(wv)+"_fft",dimsize(wv,1))

for(counter =0;counter<dimsize(wv,1);counter +=1)
	killwaves /z $("fft_cw"+num2str(counter))
endfor


end

///////////////

function GetResponseType2(wv,start,stop,blstart,blstop,thresh)
wave wv
variable start, stop, blstart,blstop,thresh

variable count=0, response, baseline

variable oncount=0,offcount=0,nocount=0 

make /o /n=(dimsize (wv,1)) ResponseType	//0...no, 1...on, 2...off

make /o/n=( dimsize(wv,0)) onr = 0
setscale /p x,dimoffset(wv,0),dimdelta(wv,0),waveunits(wv,0), onr
setscale /p y,0,1,"F/F", onr
duplicate /o  onr,offr,nor

do
	imagestats /m=2/g={start,stop,count,count} wv
		if (v_flag <0)
			print "Start/Stop out of bounds:", count
			killwaves /z onr,offr,nor
			return -1
		endif
	response = v_avg
	
	imagestats /m=2/g={blstart,blstop,count,count} wv
		if (v_flag <0)
			print "Baseline variables out of bounds:", count
			killwaves /z onr,offr,nor
			return -1
		endif	
	baseline = v_avg	
		
		
	if (response > (baseline + thresh))
		onr += wv[p][count]
		ResponseType[count]=1
		oncount +=1
	elseif (response < (baseline - thresh))
		offr += wv[p][count]
		ResponseType[count]=2
		offcount +=1
	else
		nor	+= wv[p][count]
		nocount +=1
		ResponseType[count]=0
	endif
	
count +=1		
while (count < dimsize(wv,1))

onr/=oncount		//averaged ON terminals
offr/=offcount		//averaged OFF terminals
nor/=nocount		//averaged terminals without response

print "On:", oncount, "off:",offcount, "no response:",nocount 

end