#pragma rtGlobals=1		// Use modern global access method.

function showheaderinfoingraph(wave3d)

Wave Wave3D
string IACPHeader_Wavename, StringHeader_Wavename

variable zoom = 1, x_res, y_res, z_res, x_dim, y_dim, z_dim, timeperline = 1, numericwaveexists, stringwaveexists
string expdate, age, construct, filename, settings, notes

IACPHeader_Wavename=nameofwave(wave3d)+"_head"
StringHeader_Wavename=nameofwave(wave3d)+"_string"


if (!(waveexists($IACPHeader_Wavename)))
	numericwaveexists = 0
else
	numericwaveexists = 1
	duplicate /o $IACPHeader_Wavename, headcalcwave
	zoom = headcalcwave[0]
	x_res = headcalcwave[1]
	y_res= headcalcwave[2]
	z_res =  headcalcwave[3]
	timeperline = headcalcwave[4]
endif


if (!(waveexists($StringHeader_Wavename)))
	stringwaveexists = 0
else
	stringwaveexists = 1
	duplicate /o /t $StringHeader_Wavename, stringheadwave
	expdate = stringheadwave[0]
	age = stringheadwave[1]
	construct = stringheadwave[2]
	filename = stringheadwave[3]
	settings = stringheadwave[4]
	notes = stringheadwave[6]
endif

if (wintype("IACP_HeaderDisplay"))
	killwindow IACP_HeaderDisplay
endif

Display /W=(200,100,610,315) /K=1/N=IACP_HeaderDisplay as "Properties of <"+nameofwave(wave3d)+">"

if (numericwaveexists)
	
	titlebox zoomTB, win= IACP_HeaderDisplay, fsize=11, pos={20,15}, size={205,20}, title="Zoom: "+num2str(zoom), frame =0, labelback = (65535,65535,65535)
	if (x_res >= 1)
		titlebox xresTB, win= IACP_HeaderDisplay, fsize=11, pos={20,45}, size={205,20}, title="X resolution: "+num2str(x_res)+" m per pixel", frame =0, labelback = (65535,65535,65535)
	else
		titlebox xresTB, win= IACP_HeaderDisplay, fsize=11, pos={20,45}, size={205,20}, title="X resolution: "+num2str(1000*x_res)+" nm per pixel", frame =0, labelback = (65535,65535,65535)
	endif
	if (y_res >=1)
		titlebox yresTB, win= IACP_HeaderDisplay, fsize=11, pos={20,75}, size={205,20}, title="Y resolution: "+num2str(y_res)+" m per pixel", frame =0, labelback = (65535,65535,65535)
	else
		titlebox yresTB, win= IACP_HeaderDisplay, fsize=11, pos={20,75}, size={205,20}, title="Y resolution: "+num2str(1000*y_res)+" nm per pixel", frame =0, labelback = (65535,65535,65535)
	endif
	titlebox timeperlineTB, win= IACP_HeaderDisplay, fsize=11, pos={225,15}, size={205,20}, title=num2str(timeperline)+" ms per line", frame=0, labelback = (65535,65535,65535)
	titlebox zresTB, win= IACP_HeaderDisplay, fsize=11, pos={225,45}, size={205,20}, title="Framerate: "+num2str(1000/z_res)+" Hz", frame =0, labelback = (65535,65535,65535)
	titlebox zres2TB, win= IACP_HeaderDisplay, fsize=11, pos={225,75}, size={205,20}, title="1 frame every "+num2str(z_res)+" ms", frame =0, labelback = (65535,65535,65535)

else
titlebox WDNE_numTB, win= IACP_HeaderDisplay, fsize=11, pos={20,20}, size={180,20}, title="Wave does not exist: "+IACPHeader_Wavename


endif
if (stringwaveexists)
	titlebox DateTB, win= IACP_HeaderDisplay, fsize=11, pos={20,120}, size={205,20}, title="Date: "+expdate, frame =0, labelback = (65535,65535,65535)
	titlebox AgeTB, win= IACP_HeaderDisplay, fsize=11, pos={20,150}, size={205,20}, title="Age of test subject: "+age, frame =0, labelback = (65535,65535,65535)
	titlebox ConstructTB, win= IACP_HeaderDisplay, fsize=11, pos={20,180}, size={205,20}, title="Construct: "+construct, frame =0, labelback = (65535,65535,65535)
	titlebox filenameTB, win= IACP_HeaderDisplay, fsize=11, pos={225,120}, size={205,20}, title="Filename: "+filename, frame =0, labelback = (65535,65535,65535)
	titlebox settingsTB, win= IACP_HeaderDisplay, fsize=11, pos={225,150}, size={205,20}, title="Settings: "+settings, frame =0, labelback = (65535,65535,65535)
	titlebox notesTB, win= IACP_HeaderDisplay, fsize=11, pos={225,180}, size={205,20}, title="Notes: "+notes, frame =0, labelback = (65535,65535,65535)

else
titlebox WDNE_strTB, win= IACP_HeaderDisplay, fsize=11, pos={20,120}, size={180,20}, title="Wave does not exist: "+StringHeader_Wavename

endif



killwaves/z headcalcwave, stringheadwave
end