#pragma rtGlobals=1		// Use modern global access method.
#include "customcolor"
#include "populationwave"
#include "EqualizeScaling"

function kmClusterDisplay(picwave, roiwave)
wave picwave, roiwave

variable xdim, ydim, ROInumber, ClassNumber, zdim, xcount, ycount, zcount, roicount, newroivalue
xdim = dimsize(picwave, 0)
ydim = dimsize(picwave, 1)

wave w_kmmembers
wave m_kmclasses

if ((xdim != dimsize(roiwave, 0)) & (ydim != dimsize(roiwave, 1)))
	print "Picwave dimensions don't fir ROIwave (kmClusterDisplay)."
	print "Abort"
	return -1
endif

if (waveexists(W_KMMembers) < 1)
	print waveexists(W_KMMembers)
	print "W_KMMembers doesn't exists - run KMeans with /OUT=2"
	return -1
endif

if (!(waveexists(M_KMClasses)))
	print "M_KMClasses doesn't exists - run KMeans with /OUT=2"
	return -1
endif


ROinumber = dimsize(W_KMMembers, 0)
ClassNumber = dimsize(M_KMClasses, 1)
zdim = dimsize(M_KMClasses, 0) - 1

duplicate /o roiwave KMROIwave

ycount = 0
do
	xcount = 0
	do
	
	if (roiwave[xcount][ycount] < 0)
		roicount = -roiwave[xcount][ycount] - 1
		newroivalue =-W_KMMembers[roicount] - 1
		KMROIwave[xcount][ycount]= newroivalue
	endif
	
	xcount +=1
	while(xcount < xdim)
ycount +=1
while (ycount<ydim)

string colorwavename = "KM_CD_Colorwave"

RainbowLUT(roinumber, colorwavename)

display /k=1; appendimage picwave
appendimage KMROIwave
ModifyImage KMROIwave ctab= {*,0,RAINBOW,0};DelayUpdate
ModifyImage KMROIwave minRGB=0,maxRGB=NaN
TextBox /W=$s_name /A=MT "Clusters"




end

/////////////////////////////////////////////////////////////

function kMeansDisplay()
variable ROInumber, ClassNumber, counter, zdim
string tempwavename

wave w_kmmembers
wave m_kmclasses

if (!(waveexists(W_KMMembers)))
	print "W_KMMembers doesn't exists - run KMeans with /OUT=2"
	return -1
endif

if (!(waveexists(M_KMClasses)))
	print "W_KMMembers doesn't exists - run KMeans with /OUT=2"
	return -1
endif


ROinumber = dimsize(W_KMMembers, 0)
ClassNumber = dimsize(M_KMClasses, 1)
zdim = dimsize(M_KMClasses, 0) - 1

wave M_KMClasses

For(counter=0;counter<ClassNumber;counter+=1)
tempwavename = "KM_Wave"+Num2Str(counter)
make /o /n=(zdim) $tempwavename = M_KMClasses[p][counter]
display /k=1 $tempwavename

endfor

end

/////////////////////////////////////////////////////////////

function kMeansDisplayAll(basename)
string basename
variable ROInumber, ClassNumber, counter, zdim 
string tempwavename, tempgraphname

wave w_kmmembers
wave m_kmclasses
variable class

if (!(waveexists(W_KMMembers)))
	print "W_KMMembers doesn't exists - run KMeans with /OUT=2"
	return -1
endif

if (!(waveexists(M_KMClasses)))
	print "W_KMMembers doesn't exists - run KMeans with /OUT=2"
	return -1
endif


ROinumber = dimsize(W_KMMembers, 0)

ClassNumber = dimsize(M_KMClasses, 1)

zdim = dimsize(M_KMClasses, 0) - 1

wave M_KMClasses

For(counter=0;counter<ClassNumber;counter+=1)
	tempwavename = "Class_"+Num2Str(counter)
	
	if (wintype(tempwavename))
		killwindow $tempwavename
	endif
	
	display /k=1 /n=$tempwavename as tempwavename
endfor

counter = 0

do
	class=w_kmmembers[counter]
	
	tempgraphname= "Class_"+Num2Str(class)
	
	tempwavename=basename+Num2Str(counter)
	appendtograph /w=$tempgraphname $tempwavename


counter +=1
while(counter<roinumber)

end

/////////////////////////////////////////////////////////////
//transpose populationwave for FPC!

function FPCDisplayAll(basename)
string basename
variable ROInumber, ClassNumber, counter, zdim 
string tempwavename, tempgraphname

wave w_FPClusterindex
wave w_FPCenterindex
wave M_ClustersCM
variable class

if (!(waveexists(w_FPClusterindex)))
	print " w_FPClusterindex doesn't exist."
	return -1
endif

if (!(waveexists(w_FPCenterindex)))
	print "w_FPCenterindex doesn't exist."
	return -1
endif

if (!(waveexists(M_ClustersCM)))
	print "M_ClustersCM doesn't exist. "
	return -1
endif


ROInumber = dimsize(w_FPClusterindex, 0)

ClassNumber = dimsize(w_FPCenterindex, 0)

zdim = dimsize(M_ClustersCM, 0)



For(counter=0;counter<ClassNumber;counter+=1)
	tempwavename = "FPCClass_"+Num2Str(counter)
	
	if (wintype(tempwavename))
		killwindow $tempwavename
	endif
	
	display /k=1 /n=$tempwavename as tempwavename
endfor

counter = 0

do
	class=W_FPClusterIndex[counter]
	
	tempgraphname= "FPCClass_"+Num2Str(class)
	
	tempwavename=basename+Num2Str(counter)
	appendtograph /w=$tempgraphname $tempwavename


counter +=1
while(counter<roinumber)

end

//////////////////////////////////////////////////////////////////

function /s FPClusterDisplay(picwave, roiwave)
wave picwave, roiwave
variable hide

variable xdim, ydim, ROInumber, ClassNumber, zdim, xcount, ycount, zcount, roicount, newroivalue
xdim = dimsize(picwave, 0)
ydim = dimsize(picwave, 1)

wave w_FPClusterindex
wave W_FPCenterindex

if ((xdim != dimsize(roiwave, 0)) & (ydim != dimsize(roiwave, 1)))
	print "Picwave dimensions don't fir ROIwave (kmClusterDisplay)."
	print "Abort"
	return "-1"
endif

if (waveexists( w_FPClusterindex) < 1)
	print waveexists( w_FPClusterindex)
	print " w_FPClusterindex doesn't exists - run KMeans with /OUT=2"
	return "-1"
endif

if (!(waveexists(W_FPCenterindex)))
	print "W_FPCenterindex doesn't exists - run KMeans with /OUT=2"
	return "-1"
endif



ROinumber = dimsize( w_FPClusterindex, 0)
ClassNumber = dimsize(w_FPCenterIndex, 0)
zdim = dimsize(M_ClustersCM, 0)

duplicate /o roiwave FPCROIwave

CopyScaling(picwave, FPCROIwave)

ycount = 0
do
	xcount = 0
	do
	
	if (roiwave[xcount][ycount] < 0)
		roicount = -roiwave[xcount][ycount] - 1
		newroivalue =- w_FPClusterindex[roicount] - 1
		FPCROIwave[xcount][ycount]= newroivalue
	endif
	
	xcount +=1
	while(xcount < xdim)
ycount +=1
while (ycount<ydim)

string colorwavename = "FP_CD_Colorwave"

RainbowLUT(roinumber, colorwavename)

display /k=1; appendimage picwave
appendimage FPCROIwave
ModifyImage FPCROIwave ctab= {*,0,RAINBOW,0};DelayUpdate
ModifyImage FPCROIwave minRGB=0,maxRGB=NaN
TextBox /W=$s_name /A=MT "Clusters"
ModifyGraph height = 300, width = 300

return s_name

end

/////////////////////////////////////////////////////////////////

function AutoFPC(popwave, [normalization,transname,silname])		//uses the non-transposed populationwave (i.e. traces in rows)
wave popwave
variable normalization
string transname,silname

if (paramisdefault(normalization))
	normalization = 0
endif

transposeXY(popwave,"FPCCalcwave")
wave FPCCalcWave

variable tracenumber = dimsize(popwave, 1), xdim = dimsize(PopWave,0)
variable counter

make /o/n=(tracenumber) AutoFPCwave

for(counter=0;counter<tracenumber;counter+=1)

	if (normalization)
		fpclustering /nor /cm /incd /shub=(counter) FPCCalcWave
	else	
		fpclustering /cm /incd /shub=(counter) FPCCalcWave
	endif
	AutoFPCWave[counter] = SilFromFPC(popwave)
endfor

wavestats /q /m=1 AutoFPCWave

if (normalization)
		fpclustering /nor /cm /incd /shub=(V_maxloc) FPCCalcWave
	else	
		fpclustering /cm /incd /shub=(V_maxloc) FPCCalcWave
endif

if (paramisdefault(transname) != 1)
	duplicate FPCCalcWave, $transname
endif

if (paramisdefault(silname) != 1)
	duplicate AutoFPCWave, $silname
endif

killwaves /z autofpcwave, FPCCalcWave
return V_maxloc

end


/////////////////////////////////////////////////////////////////////
	//a(i) = average dist. of items within cluster
	//b(i) = min dist. of cluster to next
	//sil(i) = (b(i) - a(i))/max(a(i),b(i))
function SilFromFPC(popwave)		//calculates the shilouette width; uses the non-transposed populationwave (i.e. traces in rows)
wave popwave

wave w_FPClusterindex
wave w_FPCenterindex
wave M_ClustersCM
wave M_InterClusterDistance
variable class, ROInumber,ClassNumber,zdim, counter, classcounter,bi, maxitemnumber, itemcounter, ai

if (!(waveexists(w_FPClusterindex)))
	print " W_FPClusterindex doesn't exist."
	return -1
endif

if (!(waveexists(w_FPCenterindex)))
	print "W_FPCenterindex doesn't exist."
	return -1
endif

if (!(waveexists(M_ClustersCM)))
	print "M_ClustersCM doesn't exist. "
	return -1
endif

if (!(waveexists(M_InterClusterDistance)))
	print "M_InterClusterDistance doesn't exist. Run FPC with /INCD"
	return -1
endif

wavestats /q/m=1 w_FPCenterindex
maxitemnumber = V_Max


ROInumber = dimsize(w_FPClusterindex, 0)

ClassNumber = dimsize(w_FPCenterindex, 0)

zdim = dimsize(M_ClustersCM, 0)

make /o/n=(ClassNumber) SilCalcwave = 0
make /o/n=(zdim) aiWave = 0
make /o/n=(ClassNumber) biWave 

classcounter = 0
do
	itemcounter = 0
	do
	
		if(W_FPClusterindex[itemcounter] == classcounter)
			aiWave[] += abs(popwave[p][w_FPCenterindex[classcounter]] - popwave[p][itemcounter])
		endif
		
		itemcounter +=1
	while (itemcounter < ROInumber)

	aiwave /= roinumber
	biwave = M_InterClusterDistance[p][classcounter]
	
	for(counter=0;counter < ClassNumber;Counter+=1)
		if(biwave[counter] == 0)
			biwave[counter] = NaN
		endif
	
	endfor
	
	wavestats /Q/m=1 BiWave
	bi = V_min
	wavestats /q/m=1 aiWave
	ai = V_Avg
	SilCalcWave[classcounter] = (bi-ai)/max(bi,ai)
	

classcounter +=1
while (classcounter<classnumber)



wavestats /Q/m=1 /q SilCalcWave

killwaves /z SilCalcWave, biWave, aiWave
return V_avg
end

//////////////////////////////////////////////////////////////////

Function FPC2Notebook(basename, picwave, ROIwave, [colorwave])
string basename
wave picwave, roiwave, colorwave

string ImageName

variable ROInumber, ClassNumber, counter, zdim, layoutnumber = 0, color = 0
string tempwavename, tempgraphname, layoutname

wave w_FPClusterindex
wave w_FPCenterindex
wave M_ClustersCM
variable class

if (!(paramisdefault(colorwave)))
	color = 1
endif

if (!(waveexists(w_FPClusterindex)))
	print " w_FPClusterindex doesn't exist."
	return -1
endif

if (!(waveexists(w_FPCenterindex)))
	print "w_FPCenterindex doesn't exist."
	return -1
endif

if (!(waveexists(M_ClustersCM)))
	print "M_ClustersCM doesn't exist. "
	return -1
endif


ROInumber = dimsize(w_FPClusterindex, 0)

ClassNumber = dimsize(w_FPCenterindex, 0)

zdim = dimsize(M_ClustersCM, 0)

LayoutName = basename+"_FPC"

For(counter=0;counter<ClassNumber;counter+=1)
	tempwavename = "FPCClass_"+Num2Str(counter)
	
	if (wintype(tempwavename))
		killwindow $tempwavename
	endif
	
	display /k=1 /hide=1 /n=$tempwavename as tempwavename
	
	
	TextBox /W=$tempwavename /A=RT "Cluster #"+num2str(counter)
endfor

counter = 0

do
	class=W_FPClusterIndex[counter]
	
	tempgraphname= "FPCClass_"+Num2Str(class)
	
	tempwavename=basename+Num2Str(counter)
	
	if (color)
		appendtograph /w=$tempgraphname /c=(colorwave[counter+1][0],colorwave[counter+1][1],colorwave[counter+1][2]) $tempwavename
	else
		appendtograph /w=$tempgraphname /c=(0,0,0) $tempwavename
	endif

counter +=1
while(counter<roinumber)

//----------------------------------Layout
ImageName = FPClusterDisplay(picwave, roiwave)	//<----------------
Dowindow /hide=1 ImageName

NewLayout /k=1 /p=Landscape /n=$layoutname+Num2Str(LayoutNumber)
AppendLayoutObject graph $ImageName
Execute /Q/Z "Tile /A=(1,1)"
DoUpdate

layoutnumber +=1
If (WinType(layoutname+num2str(layoutnumber)))
	killwindow $layoutname+num2str(layoutnumber)
endif

NewLayout  /k=1/p=landscape /n=$layoutname+num2str(layoutnumber)

counter = 0
variable counter2 = 0

do
	tempgraphname= "FPCClass_"+Num2Str(counter)
	if ((mod(counter2, 6) > 0) | (counter2 == 0))	
		AppendLayoutObject /w=$layoutname+Num2Str(LayoutNumber) graph $tempgraphname
	elseif  ((mod(counter2, 6) == 0))
			DoWindow /F $layoutname+num2str(layoutnumber)
			Execute /Q/Z "Tile /A=(3,2)"
			LayoutNumber +=1
			If (WinType(layoutname+num2str(layoutnumber)))
				killwindow $layoutname+num2str(layoutnumber)
			endif
			NewLayout  /k=1/p=landscape /n=$layoutname+num2str(layoutnumber)	//S_name = name
			AppendLayoutObject /w=$layoutname+num2str(layoutnumber) graph $tempgraphname
	else
		DoAlert 0, "Now this shouldn't happen... (IACP_clustering.ipf /  FPC2Notebook)"
	endif

counter +=1
counter2+=1
while (counter < (zdim))

Execute /Q/Z "Tile /A=(3,2)"


//-----------------------------------Notebook
string notebookname = basename+"FPC_Summary"

if (wintype(notebookname))
	DoAlert 1, "A window named "+notebookname+" already exists. Kill in order to proceed?"
		if (v_flag != 1)
			print "FPC2notebook halted"
			return -1
		else
			Killwindow $notebookname
		endif
endif

NewNotebook /f=1 /n=$(notebookname) as notebookname
Notebook $(notebookname), fsize = 11, fstyle = 0, textrgb=(65535,65535,65535)
Notebook $(notebookname), text="FPC Summary of "+basename+"\r"
Notebook $(notebookname), text="Number of traces: "+num2str(ROinumber)+"\r"
Notebook $(notebookname), text="Number of clusters "+num2str(zdim)+"\r"+"\r"
//Notebook $(notebookname), scaling={58,60}, picture={$layoutname+"0", 1,1}

counter = 0	
do

		Notebook $(notebookname), scaling={58,60}, picture={$layoutname+num2str(counter), 1,1}
		dowindow /hide=1 $layoutname+Num2Str(counter)

		counter +=1
while (counter < (layoutnumber +1)) 
		dowindow /hide=1 $layoutname+Num2Str(counter)
		dowindow /hide=1 $Imagename

killwaves /z tempcolorwave

end

////////////////////////////////////////////////////////
