#pragma rtGlobals=1		// Use modern global access method.

Function MakeKernel(wv, KernelCoefs)
wave wv, KernelCoefs

variable k0,k1,k2,k3,k4,k5,k6

k0=KernelCoefs[0]			//z0
k1=KernelCoefs[1]			//A
k2=0//KernelCoefs[2]		//x0
k3=KernelCoefs[3]			//xWidth
k4=0//KernelCoefs[4]		//y0
k5=KernelCoefs[5]			//yWidth
k6=KernelCoefs[6]			//cor

k3=(k3+k5)/2			//make it symmetric
k5=k3
k0=0
k6=0
k1=1

duplicate /o wv, kernel

kernel=K0+K1*exp((-1/(2*(1-K6^2)))*(((x-K2)/K3)^2 + ((y-K4)/K5)^2 - (2*K6*(x-K2)*(y-K4)/(K3*K5)))) //2D Gaussian

wavestats /q kernel
kernel/=v_sum		//integral = 1

end


Function ImageDeconvolve(Image, Kernel)
wave image, kernel

FFT /out=1/dest=Image_fft Image
FFT /out=1/dest=Kernel_fft Kernel
wave/c kernel_fft, image_fft

duplicate /o/c image_fft, decon_calc
decon_calc=image_fft/kernel_fft

IFFT /Dest=M_DeconvolvedImage decon_calc

killwaves/z kernel_ft, image_fft,decon_calc

end

Function ImgDec(wv, KernelCoefs)
wave wv, KernelCoefs

MakeKernel(wv, KernelCoefs)
wave Kernel

ImageDeconvolve(wv, Kernel)

end