#pragma rtGlobals=1		// Use modern global access method.

function ImgIntensity(Picwave, outputwave)
wave picwave
string outputwave

variable xdim, ydim, xcount = 0, ycount = 0

xdim = dimsize(picwave, 0)
ydim = dimsize(picwave, 1)

make /o/n=(xdim * ydim) calcwave
//wave $outputwave

do
xcount = 0
	do
	calcwave[(xcount)+(ycount * xdim)] = picwave[xcount][ycount]
	
	xcount +=1
	while (xcount < xdim)
ycount += 1
while(ycount < ydim)

make /o/n=(xdim * ydim) $outputwave = calcwave
killwaves /z calcwave
return xdim*ydim
end

/////////////////////////////////////////////

function StackIntensity(Picwave, outputwave)
wave picwave
string outputwave

variable xdim, ydim, xcount = 0, ycount = 0, zdim, zcount = 0

xdim = dimsize(picwave, 0)
ydim = dimsize(picwave, 1)
zdim = dimsize(picwave, 2)

make /o/n=(xdim * ydim * zdim) calcwave
//wave $outputwave

do
ycount = 0
	do
	xcount = 0
		do
		calcwave[(xcount)+(ycount * xdim)+ (xdim * ydim * zcount)] = picwave[xcount][ycount][zcount]
		
		xcount +=1
		while (xcount < xdim)
	ycount += 1
	while(ycount < ydim)
zcount +=1
while (zcount < zdim)
	
	make /o/n=(xdim * ydim * zdim) $outputwave = calcwave
	killwaves /z calcwave
	return xdim*ydim*zdim
end

/////////////////////////////////////////////

function StackIntensityLineAvg(Picwave, outputwave)
wave picwave
string outputwave

variable xdim, ydim, xcount = 0, ycount = 0, zdim, zcount = 0, linesum

xdim = dimsize(picwave, 0)
ydim = dimsize(picwave, 1)
zdim = dimsize(picwave, 2)

make /o/n=(ydim * zdim) calcwave
//wave $outputwave

do
ycount = 0
	do
	xcount = 0
	linesum = 0
		do
		linesum += picwave[xcount][ycount][zcount]
		xcount +=1
		while (xcount < xdim)
		calcwave[ycount + (ydim * zcount)] = linesum / xdim
	ycount += 1
	while(ycount < ydim)
zcount +=1
while (zcount < zdim)
	
	make /o/n=(ydim * zdim) $outputwave = calcwave
	killwaves /z calcwave
	return ydim*zdim
end