#pragma rtGlobals=1		// Use modern global access method.
#pragma rtGlobals=1		// Use modern global access method.

Menu "Macros"
	"LoadTiff", loadTiff()
end

Function loadTiff()
	
	variable fileRef
	variable xDim,dataType,yDim,ADCres=16
	variable inc, pointpos
	string/g imageName
	variable/g V_filter = 1
	string tmp, info, name2
	variable/g numImages, currentImage0 = 1, AnimStartVar = 1, AnimStopVar = 10 , AnimRateVar = 0.05
	variable/g displayMin = 0, displayMax = 2^ADCres
	variable/g selectPointX = 0, selectPointY = 0
	variable/G gFRate
	
	ImageLoad /c=-1 /o /t=tiff
	name2 = replacestring(";", S_Wavenames, "")
	PointPos = strsearch(name2, ".tif", 0)
	ImageName = name2[0,PointPos-1]
	rename $name2, $imagename
	


	xdim = dimsize($ImageName, 0)
	ydim = dimsize($ImageName, 1)
	numImages = dimsize($ImageName, 2) + 1
	info = waveinfo($ImageName,0)
	datatype = NumberByKey("NUMTYPE", info)
	
//	open /r/t="????" fileRef
//	
//	FSetPos fileRef,10
//	FBinRead /B=2 /F=3  fileRef, yDim
//
//	FSetPos fileRef,6
//	FBinRead /B=2 /F=3  fileRef, xDim
//
//	FSetPos fileRef,5
//	FBinRead /B=2 /F=1  fileRef, dataType	
//	
//	FSetPos fileRef,20
//	FBinRead /B=2 /F=2  fileRef, numImages

	if(dataType!=6)	
		Redimension /W/U $ImageName
		Print "Redimensioning <"+ImageName+"> to 16bit unsigned."
		Print "I'm not sure whether this is necessary, but Bjrn did it (kind of)."
	endif

	AnimStopVar = numImages
	print S_filename
	print xDim,"X",yDim,"pixels"
	//print dataType
	print numImages, "frames"
	
//	//read in file name
//	inc = strlen(S_filename)-5
//	do
//		inc -= 1
//		tmp = S_filename[inc]
//	while(cmpstr(tmp,":")!=0)
//		
//	imageName = S_filename[inc+1,strlen(S_filename)]
	//make/o/u/w/n=(xDim,yDim,numImages) $imageName
	make/o/n=(xDim,yDim) buffer1//, buffer1_bGround
//	buffer1_bGround = 0
	//read in data
//	FSetPos fileRef,2120
//	FBinRead /B=2 /F=2  fileRef, $imageName
//	
//	close fileRef
	
	//make graph
	buffer1 = 1
	if(wintype("IPbuffer")!=0)
		dowindow /k IPbuffer
	endif
	
	//display /M/W=(1,2,25,12); AppendImage buffer1
	newimage buffer1
	dowindow /c IPbuffer
	SetAxis/A/R left
	
	//
	variable graphWidth = 300 * (xDim/yDim)
	//
	
	ModifyGraph width=(graphWidth), height=300
	ModifyGraph margin(bottom)=20,margin(left)=25,margin(top)=20,margin(right)=20
	ModifyGraph fSize=12
	wavestats/q buffer1
	displayMin = floor(V_min)
	displayMax = ceil(V_max)
	ModifyImage buffer1 ctab= {(displayMin),(displayMax),Grays,0}

	doupdate

	askFramerate()
	
	if(wintype("WMImageRangeGraph")==0)
		WMCreateImageRangeGraph()
	endif
	
	//make control panel
	if(wintype("IPpanel")!=0)
		dowindow /k IPpanel
	endif
	NewPanel /W=(500,24,698,324) as "IP Control"
	Dowindow /C IPpanel
	//current image control
	SetVariable setImage0 pos={28,28},size={142,28},proc=SetVarProc
	SetVariable setImage0 title="Current Image",font="Arial",limits={1,(numImages),1}
	SetVariable setImage0 value= currentImage0
	//animation controls
	Button Animate0 pos={28,56},size={142,28},proc=ButtonProc,title="Animate"
	
	SetVariable AnimStart0 pos={28,90},size={142,28}
	SetVariable AnimStart0 title="AnimStart",font="Arial",limits={1,(numImages),1}
	SetVariable AnimStart0 value= AnimStartVar	
	
	SetVariable AnimStop0 pos={28,115},size={142,28}
	SetVariable AnimStop0 title="AnimStop",font="Arial",limits={(AnimStartVar+1),(numImages),1}
	SetVariable AnimStop0 value= AnimStopVar
	
	SetVariable AnimRate0 pos={28,140},size={142,28}
	SetVariable AnimRate0 title="AnimRate",font="Arial",limits={0,10,0.05}
	SetVariable AnimRate0 value= AnimRateVar		
	
//	SetVariable DispMin0 pos={28,175},size={142,28},proc=SetDispProc
//	SetVariable DispMin0 title="displayMin",font="Arial",limits={0,(2^ADCres-1),50}
//	SetVariable DispMin0 value= displayMin	
//	
//	SetVariable DispMax0 pos={28,200},size={142,28},proc=SetDispProc
//	SetVariable DispMax0 title="displayMax",font="Arial",limits={0,(2^ADCres-1),50}
//	SetVariable DispMax0 value= displayMax
//	
//	SetVariable selX pos={28,235},size={142,28}
//	SetVariable selX title="selectX",font="Arial",limits={0,xDim,1}
//	SetVariable selX value= selectPointX	
//	
//	SetVariable selY pos={28,260},size={142,28}
//	SetVariable selY title="selectY",font="Arial",limits={0,yDim,1}
//	SetVariable selY value= selectPointY
	
	SetDrawLayer/K UserFront
	SetDrawLayer UserFront
	DrawText 28,195, ImageName
	DrawText 28,210, "(x)"+num2str(xDim)+" x (y)"+num2str(yDim)+" pixels"
	DrawText 28,225, num2str(numImages)+" frames"
	DrawText 28,240, "Framerate: "+num2str(gFRate)+" /s"
	
	SetWindow IPPanel, hook=IPHook
	
	//rename folder
	if(stringmatch(GetDataFolder(0),"folder0") == 1)
		 FPRenameDataFolderDo(GetDataFolder(0),ImageName)
	endif	
	
end


Function askFramerate()
	Variable fRate
	Prompt fRate, "Number of frames per second?"
	Doprompt "Framerate", frate
	
	Variable/G gFRate = fRate
	
End
