#pragma rtGlobals=1		// Use modern global access method.

Function M_Threshold(inputwave, outputwave, levels)
Wave inputwave
String Outputwave
variable levels

variable xdim, ydim, xcount = 0, ycount = 0, minval, maxval, range

If (DimSize(inputwave, 2))
	Print "Running thresholding on a stack"
	Print "Only First Layer will be affected"
endif

xdim = dimsize(inputwave, 0)
ydim = dimsize(inputwave, 1)

make /o/n=(xdim,ydim) calcwave

minval = inputwave[0][0]
maxval = inputwave[0][0]

//getting min/max values

do
	ycount = 0
	do
	if (inputwave[xcount][ycount] < minval)
		minval = inputwave[xcount][ycount]
	elseif (inputwave[xcount][ycount] > maxval)
		maxval = inputwave[xcount][ycount]
	endif
	ycount +=1
	while (ycount < ydim)
xcount +=1
while (xcount < xdim)

range = maxval - minval

xcount = 0
do
	ycount = 0
	do
	
	calcwave[xcount][ycount] = trunc((inputwave[xcount][ycount] - minval) *levels / range)
	
	ycount +=1
	while (ycount < ydim)
xcount +=1
while (xcount < xdim)

make /o/n=(xdim,ydim) $outputwave = calcwave
killwaves /z calcwave

end

////////////////////thres 2 roi//////////////////


function thresh2roi(inputwave, outputwave)
Wave inputwave
String Outputwave


variable xdim, ydim, xcount = 0, ycount = 0

If (DimSize(inputwave, 2))
	Print "Running thresholding on a stack"
	Print "Only First Layer will be affected"
endif

xdim = dimsize(inputwave, 0)
ydim = dimsize(inputwave, 1)

duplicate /o inputwave, calcwave



do
	ycount = 0
	do
	
	if(inputwave[xcount][ycount])
	calcwave[xcount][ycount] = 0 //zero ROI pixels
	else
	calcwave[xcount][ycount] = 1
	endif
	
	ycount +=1
	while (ycount < ydim)
xcount +=1
while (xcount < xdim)


duplicate /o calcwave, $outputwave
killwaves /z calcwave
end
//////////////////////ROI 2 cartesian//////////////////////
function ROI2Cartesian(ROIWave, outputwave)
wave ROIWave
string outputwave

variable xdim, ydim, xcount, ycount, roinumber = 0, roicount = 0, pixelcount, roicountmax = 0

xdim = dimsize(ROIWave, 0)
ydim = dimsize(ROIWave, 1)

ycount = 0
do
	xcount = 0
	do
		if (ROIwave[xcount][ycount] < -roinumber)
			roinumber = -ROIwave[xcount][ycount]
		endif
	xcount +=1
	while (xcount < xdim)
ycount +=1
while (ycount < ydim)

make /c/o/n=(roinumber, round(xdim*ydim/roinumber)) R2C_calcwave = -1

roicount = 0
do
	pixelcount = 0
	ycount = 0
	do
		xcount = 0
		do
			if (ROIwave[xcount][ycount] == -(roicount + 1))
				R2C_calcwave[roicount][pixelcount] = cmplx(xcount,ycount)
				pixelcount +=1
				if (pixelcount > roicountmax)
					roicountmax = pixelcount
				endif
			endif
		xcount +=1
		while (xcount < xdim)
	ycount +=1
	while (ycount < ydim)
roicount +=1
while (roicount < roinumber)


redimension /n=(roinumber, roicountmax) R2C_calcwave 
duplicate /o R2C_calcwave, $outputwave
killwaves /z R2C_calcwave

return roicountmax
end
////////////////////////cartesian 2 image//////////////////
function Cartesian2Image(CartWave, outputwave)
wave /c CartWave
wave outputwave

variable  roinumber, roicount = 0, pixelnumber, pixelcount

roinumber = dimsize(cartWave, 0)
pixelnumber = dimsize(cartWave, 1)

do
	pixelcount = 0
	do
		if(real(cartwave[roicount][pixelcount]))
		outputwave[real(cartwave[roicount][pixelcount])][imag(cartwave[roicount][pixelcount])] = -roicount - 1
		endif
	pixelcount +=1
	while (pixelcount < pixelnumber)

roicount +=1
while (roicount < roinumber)

end

//////////////////////////cart2imag + value///////////////////////////

function cart2imag(cartwave, imagewave,value)
wave /c cartwave
wave imagewave
variable value

variable pixnumber = dimsize(cartwave,0)
variable counter

counter=0
do
imagewave[real(cartwave[counter])][imag(cartwave[counter])] = value

counter+=1
while(counter<pixnumber)

end


////////////////in ellipse?///////////////////////

function inellipse(pointx, pointy, xcenter, ycenter, xradius, yradius)
variable pointx, pointy, xcenter, ycenter, xradius, yradius
variable distance

distance = ((xcenter - pointx)^2 / xradius^2 )+ ((ycenter - pointy)^2 / yradius^2) - 1

return  -distance		//if distance < 0 then the point is outside the ellipse
end

/////////////////////////////////////drawellipse//////////////

function drawellipse(xcenter,ycenter,xradius,yradius, outputwave)
variable xcenter,ycenter,xradius,yradius
string outputwave


variable /c startpix=cmplx(xcenter - xradius, ycenter - yradius)
variable /c endpix=cmplx(xcenter + xradius+1,ycenter + yradius+1)
variable xcount=real(startpix), ycount=imag(startpix), pixelcount=0

make /o/c/n=(xradius*yradius*4) decalcwave

do
	xcount=real(startpix)
	do 
		if (inellipse(xcount,ycount,xcenter,ycenter,xradius,yradius) >= 0 )
			decalcwave[pixelcount]=cmplx(xcount,ycount)
			pixelcount +=1
		endif
	
	xcount +=1
	while (xcount < real(endpix))
ycount +=1
while (ycount < imag(endpix))

make /o/c/n=(pixelcount) $outputwave = decalcwave
killwaves /z decalcwave
return pixelcount


end

///////////////////on line?//////////////////////////////
function online(referencex,referencey,x1,y1,x2,y2)
variable referencex,referencey,x1,y1,x2,y2

variable k, d

if (x2 > x1)
k = (y2-y1)/(x2-x1)
elseif (x1 > x2)
k = (y1-y2)/(x1-x2)
else
k = inf
endif

d = y2 - k*x2

if (round(k*referencex + d - referencey) == 0)
return 1
elseif ((x1 == x2) & (referencex == x1))
return 1
return 0
endif

end


////////////////////////Refinement////////////////////////

Function RefineThr2(ROIwave, PICwave, outputwave, roinumber, xradius, yradius)
//radius...radius to search for multiple ROIs
Wave ROIWave, PICwave
String Outputwave
variable roinumber, xradius, yradius

variable runs	=0 ,stopcondition=xradius*yradius*pi	//debug only

variable xdim, ydim, xcount, ycount, roicounter, sizecounter = 0, xradiusnow, yradiusnow, maxradius, newroicount = 1, maxroisize, counter2
variable xstart, ystart, xend, yend
string nameofduplicatewave
xdim = dimsize(ROIwave, 0)
ydim = dimsize(ROIwave, 1)

if ((dimsize(PICwave, 0) != xdim) | (dimsize(PICwave, 1) != ydim))
	print "ROIwave doesn't match PICwave dimensions (M_Threshold / RefineThr)"
	print "Abort"
	return -1
endif


maxroisize = dimsize(PICwave, 0)*dimsize(PICwave, 1)

duplicate /o picwave, refinePICcalcwave
wave refinePICcalcwave



duplicate /o ROIwave, refineROIcalcwave


refineROIcalcwave = 0
make /o /n=(roinumber) roimax = 0
make /c /o /n=(roinumber) roicenter = 0
make /c /o /n=(roinumber) roistart = 0
make /c /o /n=(roinumber) roiend = 0
make /o /n=(roinumber) roisize = 0

if (xradius > yradius)
	maxradius = xradius
else
	maxradius = yradius
endif


do
	///////////find maximum value
	ycount = 0
	do
		xcount = 0
		do
		if (refineroicalcwave[xcount][ycount] <0)		//in ROI
			roicounter = -(refineroicalcwave[xcount][ycount]) - 1
			if (runs == 0)
				roisize[roicounter] += 1
			endif

			if (roisize[roicounter] == 1)
				roistart = cmplx(xcount,ycount)	//upper left picel of ROI
			endif
			roiend = cmplx(xcount,ycount)			//lower right pixel of ROI
			
			if (refinePICcalcwave[xcount][ycount] > roimax[roicounter])	//get brightness & position of brightest px
				roimax[roicounter] = refinePICcalcwave[xcount][ycount]
				roicenter[roicounter] = cmplx(xcount,ycount)
			endif
				
		endif
		xcount +=1
		while (xcount < xdim)
	ycount +=1
	while (ycount < ydim)

	//////////////blank ROIs
	
	roicounter = 0
	do
		xradiusnow = 0
		yradiusnow = 0
		do
			ycount = imag(roistart[roicounter])
			do
				xcount = real(roistart[roicounter])
				do
				
					if ((inellipse(xcount,ycount,real(roicenter[roicounter]),imag(roicenter[roicounter]),xradius,yradius) < 0 ) & (inellipse(xcount,ycount,real(roicenter[roicounter]),imag(roicenter[roicounter]),xradius+sqrt(2),yradius+sqrt(2)) < 0 ) >= 0)
						refinepiccalcwave[xcount][ycount] = 0
						refineroicalcwave[xcount][ycount] = -newroicount
						roisize[roicounter] -=1
					endif
						
				xcount +=1
				while(xcount<real(roiend[roicounter]))
			ycount +=1
			while (ycount < imag(roiend[roicounter]))
		
		if (xradiusnow < xradius)
			xradiusnow +=1
		endif
		if (yradiusnow < yradius)
			yradiusnow +=1
		endif
		while ((xradiusnow < maxradius) & (yradiusnow < maxradius))		
	newroicount +=1
	roicounter +=1
	while (roicounter < roinumber)

	maxroisize = 0
	for(counter2=0;counter2<roinumber;counter2+=1)
		if (roisize[counter2] > maxroisize)
			maxroisize = roisize[counter2]
		
		endif
	endfor




	runs +=1

while ((stopcondition<maxroisize))

//////////////refine

//roicounter = 0
//do
//	ycount = imag(roistart[roicounter])
//	do
//		xcount = real(roistart[roicounter])
//		do
//			if (!(roiwave[xcount][ycount]))		//in ROI
//				//<------------------------------code here
//			endif
//		xcount +=1
//		while (xcount <  real(roiend[roicounter]))
//	ycount +=1
//	while (ycount < imag(roiend[roicounter]))
//roicounter +=1
//while (roicounter < roinumber)
//

duplicate /o refineroicalcwave, $outputwave
killwaves/z roimax,roicenter,roistart,roiend, roisize,refinepiccalcwave, refineroicalcwave
return newroicount
end

//////////////////Alt. Thresholding///////////////////
Function M_Threshold2(inputwave, outputwave, levels)
Wave inputwave
String Outputwave
variable levels

variable xdim, ydim, xcount = 0, ycount = 0, minval, maxval, range

If (DimSize(inputwave, 2))
	Print "Running thresholding on a stack"
	Print "Only First Layer will be affected"
endif

xdim = dimsize(inputwave, 0)
ydim = dimsize(inputwave, 1)

duplicate /o inputwave calcwave


minval = inputwave[0][0]
maxval = inputwave[0][0]

//getting min/max values

do
	ycount = 0
	do
	if (inputwave[xcount][ycount] < minval)
		minval = inputwave[xcount][ycount]
	elseif (inputwave[xcount][ycount] > maxval)
		maxval = inputwave[xcount][ycount]
	endif
	ycount +=1
	while (ycount < ydim)
xcount +=1
while (xcount < xdim)

range = maxval - minval

xcount = 0
do
	ycount = 0
	do
		if (inputwave[xcount][ycount] < maxval -minval -levels)
			calcwave[xcount][ycount] =0
		endif
	
	ycount +=1
	while (ycount < ydim)
xcount +=1
while (xcount < xdim)

make /o/n=(xdim,ydim) $outputwave = calcwave
killwaves /z calcwave, refineROIcalcwave, refinePICcalcwave

end
