#pragma rtGlobals=1		// Use modern global access method.
#include "EqualizeScaling"


Menu "Macros"
	"Normalize point-by-point", CallNormPbP()
end

Function /t NormPbP(baseline, trace)

wave baseline, trace
string Name
variable xdim, counter = 0

if (numpnts(baseline) != numpnts(trace))
	DoAlert 0, "<"+Nameofwave(baseline)+"> and <"+Nameofwave(trace)+"> have different numbers of points."
	Return "Error!"
endif


xdim = dimsize(baseline, 0)
make /o/n=(xdim) /o PbPCalcwave
CopyScaling(trace, PbPCalcwave)			//<--- remove this line, if you don't want the result to have the same scaling as the original



do
	if(baseline[counter] == 0)
		DoAlert 2, "Baseline contains a 0. Skip this point and continue?"
		if (V_flag != 1)
			return "Error!"
		endif
	else
		PbPCalcwave[counter]=trace[counter]/baseline[counter]
	endif
	
counter +=1
while(counter<xdim)

name = nameofwave(trace)+"_norm"	//<--- change here, if the resut should have a different name
duplicate /o PbPCalcwave, $name
killwaves /z PbPCalcwave
return name
end

Function CallNormPbP()

string baseline, trace

prompt baseline, "Baseline:", popup, WaveList("*",";","")
prompt trace, "Wave to be normalized:", popup, WaveList("*",";","")

DoPrompt "Select waves", baseline, trace

If (V_flag)
	Print "Well, then not..."
	return -1
else
	print NormPbP($baseline, $trace)
endif

End