#pragma rtGlobals=1		// Use modern global access method.
//How to use:
//Data -> Load Waves -> Load Image
//Import red and green image. Note the name of the resulting waves.
//Run Pixelint(nameofredwave,nameofgreenwave)

Function Pixelint(red,green)

wave red,green

variable points, x, y
points=dimsize(red,0)*dimsize(red,1)
make /o/n=(points) red_lin

points=dimsize(green,0)*dimsize(green,1)
make /o/n=(points) green_lin

for(x=0;x<dimsize(red,0);x+=1)
	for(y=0;y<dimsize(red,1);y+=1)
	
		red_lin[(x+1)*(y+1)]=red[x][y][0]
		green_lin[(x+1)*(y+1)]=green[x][y][1]
	
	endfor
endfor

display red_lin vs green_lin
ModifyGraph Mode=2
Label left "Red"
Label bottom "Green"

display green_lin vs red_lin
ModifyGraph Mode=2
Label left "Green"
Label bottom "Red"
end


function colocalise(rgb, mode, threshold)
//mode 1= r-g, 2 = r-b, 3 = g - b

wave rgb
variable mode, threshold

variable xdim=dimsize(rgb,0), ydim=dimsize(rgb,1),xc,yc, rval, gval, col1, col2

if(dimsize(rgb,2) != 3)
	return -1
endif

if (mode==1)
	col1=0
	col2=1
elseif (mode==2)
	col1=0
	col2=2
elseif(mode==3)
	col1=1
	col2=2
else
	return -1
endif

duplicate /o rgb, coloc
redimension /n=(-1,-1) coloc
coloc=0

for(xc=0;xc<1024;xc+=1)
	for(yc=0;yc<1024;yc+=1)
		rval = rgb[xc][yc][col1]
		gval = rgb[xc][yc][col2]
		
		if((rval > threshold) && (gval > threshold))
			coloc[xc][yc] =  1//(rgb[x][y][col1] + rgb[x][y][col2]) /2
		else
			coloc[xc][yc] = 0
		endif
	endfor
endfor

if (mode==1)
	duplicate /o coloc, rg_coloc
elseif (mode==2)
	duplicate /o coloc, rb_coloc
elseif(mode==3)
	duplicate /o coloc, gb_coloc
else
	return -1
endif

killwaves coloc

end