#pragma rtGlobals=1		// Use modern global access method.
#include "z-project"
#include "normalize"
#include "multiroi"
#include "M_Threshold"
#include "ManThresh"
#include "ImGAnalCP"
#include "Customcolor"
#include "populationwave"

//////////////////////////Quick Analysis/////////////////////////////////
Function QuickAnalysis(ImageStack)
wave ImageStack
variable xdim, ydim, roinumber, counter = 0
variable /g g_ThresholdLevelNumber, g_AutoLayout, g_deltafbyf, g_AutoName, g_HeaderInfo

string targetname
string /g  g_QAStatus,g_NameOfROIWave, g_QAMethodType //"Average;SD;Raw Image"


g_QAStatus = "Starting" 
DoUpdate

if (g_AutoName)
targetname = NameOfWave(ImageStack)+"_"+g_QAMethodType[0,2]+"_QA"

else
	prompt targetname, "Enter name for target wave"
					doprompt "Graph wave", targetname
					if (V_Flag)
						g_QAStatus = "Cancelled" 
						DoUpdate
						return -1
					endif
endif

strswitch(g_NameOfROIWave)
case "Automatic":


	if (waveexists(MTROIWave) & (dimsize(MTROIWave, 0) == dimsize(Imagestack, 0)) & (dimsize(MTROIWave, 1) == dimsize(Imagestack, 1)))
		duplicate /o MTROIWave M_ROIMask
		g_QAStatus = "Using saved ROI"
		//print "Using saved ROI"						//debug only
		DoUpdate
		DoUpdate
		else
		
		strswitch(g_QAMethodType) //Average;SD;Raw Image
		Case "Average":
		g_QAStatus = "Calculating average"
		DoUpdate
		DoUpdate
		avgZ(ImageStack, "Threshold_Base")
		break
		
		Case "SD":
		g_QAStatus = "Calculating SD"
		DoUpdate
		DoUpdate
		stdevZ(ImageStack, "Threshold_Base")
		break
		
		Case "Raw Image":
		xdim = dimsize(ImageStack, 0)
		ydim = dimsize(ImageStack, 1)
		Duplicate /o ImageStack, Threshold_Base  
		Redimension /N=(xdim,ydim) Threshold_Base 
		break
		
		default:
		Print "Default Case, using Average"
		g_QAStatus = "Calculating average"
		DoUpdate
		DoUpdate
		avgZ(ImageStack, "Threshold_Base")
		break
		endswitch
	
		wave Threshold_Base
		g_QAStatus = "Thresholding"
		DoUpdate
		M_Threshold(Threshold_Base, "Thresholded_Wave", g_ThresholdLevelNumber)
			
		wave Thresholded_Wave
		g_QAStatus = "Generating ROI"
		DoUpdate
		thresh2roi(Thresholded_Wave,"M_ROIMask")
	endif	//waveexists...
break

default:	//g_NameOfROIWave
	if (waveexists($g_NameOfROIWave) & (dimsize($g_NameOfROIWave, 0) == dimsize(Imagestack, 0)) & (dimsize($g_NameOfROIWave, 1) == dimsize(Imagestack, 1)))
	duplicate /o $g_NameOfROIWave M_ROIMask
		g_QAStatus = "Using "+ g_NameOfROIWave
		DoUpdate
		DoUpdate
	elseif (waveexists($g_NameOfROIWave))
	g_QAStatus = g_NameOfROIWave+" does not match "+nameofwave(imagestack)
		DoUpdate
		DoUpdate
	else
	print "Something gone horribly wrong (QuickAnal)..."

	endif
break
endswitch
/////////////////////////BG Corr/////////////
if (g_DeltaFbyF)
	//if(waveexists (M_ROIMask))
	duplicate /o M_ROIMask M_ROIMask2
	//endif
	
	string /g g_NameOf3DWave
	string tempwavename = nameofwave($g_NameOf3DWave)+"_THR" 
	if (waveexists($tempwavename))	
		Display /n=ManualROI /hide = 0;  appendimage $tempwavename
	elseif(waveexists(threshold_base))
	wave threshold_base
	Display /n=ManualROI /hide = 0; 
	appendimage threshold_base
	else
	print "No wave for BG correction"
	Print "Abort"
	return -1
	endif
	
	WMCreateImageROIPanel();
	g_QAStatus = "Select Background & Kill ROI Window"
		DoUpdate
	PauseForUser WMImageROIPanel, $S_Name	
	if (!(waveexists(M_ROIMask)))
		g_QAStatus = "User Abort?"
		DoUpdate
		return -1
	endif
	duplicate /o M_ROIMask M_BGMask
	duplicate /o M_ROIMask2 M_ROIMask
	
	if (wintype("IAControlPanel"))
		doWindow /F IAControlPanel
	endif
	if (wintype("ManualROI"))
		doWindow /k ManualROI
	endif
	
	
	g_QAStatus = "Normalizing Background"
	doupdate; doupdate
	NormBG2(ImageStack, NameOfWave(ImageStack)+"_BGN", M_BGMask)
	killwaves/z M_BGMask, m_roimask2
	


endif

//if (waveexists(m_roimask2))
duplicate /O M_ROIMask2 M_ROIMask
killwaves /z m_roimask2
//endif



///////////////////stacking
wave M_ROIMask
doWindow /F IAControlPanel
g_QAStatus = "Generating Z stacks"
DoUpdate
DoUpdate


if (g_deltaFbyF)
	roinumber = MultiROIZstack($NameOfWave(ImageStack)+"_BGN", targetname)
	do
	normalize($targetname+"_"+num2str(counter), targetname+"_"+num2str(counter))
	counter += 1
	while (counter < roinumber)
	
	else
	roinumber = MultiROIZstack(Imagestack, targetname)
	
endif

/////////////////////////Auto Layout
variable counter2 = 2
if (g_AutoLayout)
	g_QAStatus = "Auto Layout"
	DoUpdate
	string Layoutname, expdate, age = "", construct = "", filename , settings = "", notes = "", headname, stringname, graphname
	string /g g_NameOf3DWave
	string tempwavename2 = nameofwave($g_NameOf3DWave)+"_THR" 
	variable headerexists, zoom, x_res, y_res, z_res, timeperline, layoutnumber = 1
	variable /g  g_HeaderInfo
	headname = nameofwave(ImageStack)+"_head"
	stringname = nameofwave(ImageStack)+"_string"
	
	
	string colorwavename = nameofwave(imagestack)+"_colorLUT"
	RainbowLUT(roinumber+1,colorwavename)
	
	
	duplicate /o $colorwavename, tempcolorwave
	setscale /P x,0,-1,"" $colorwavename
	

	
	
	if (waveexists($headname)&  g_HeaderInfo)
		duplicate /o $headname, headcalcwave
		headerexists = 1
		zoom = headcalcwave[0]
		x_res = headcalcwave[1]			//m
		y_res= headcalcwave[2]			//m
		z_res =  headcalcwave[3] / 1000 	//msec 2 sec
		timeperline = headcalcwave[4]
		
	endif
	
	if (waveexists($stringname)&  g_HeaderInfo)
		duplicate /o/t $stringname, stringheadwave
		expdate = stringheadwave[0]
		age = stringheadwave[1]
		construct = stringheadwave[2]
		filename = stringheadwave[3]
		settings = stringheadwave[4]
		notes = stringheadwave[6]
	else
		expdate = date()+" (Date of analysis)"
		filename = nameofwave(imagestack)
	endif
	counter = 0
	
	layoutname = targetname+"_Layout"
	
	variable lcounter = 0
	do
		if (wintype(layoutname))
		layoutname = targetname+"_"+num2str(lcounter)+"_Layout"
		lcounter +=1
		else
		lcounter = 1001
		endif
	while (lcounter < 1000)
	
	
	NewLayout /k=1 /p=landscape /n=$layoutname	//S_name = name

	
	
	
	
	
	if (waveexists($tempwavename2))
		if (headerexists &  g_HeaderInfo)
			setscale /p x 0,x_res,"m", $tempwavename2; delayupdate
			setscale /p y 0,y_res,"m", $tempwavename2; delayupdate
			setscale /p x 0,x_res,"m", $targetname+"_ROI"; delayupdate
			setscale /p y 0,y_res,"m", $targetname+"_ROI"; delayupdate
		endif
		Display /hide = 1; 
		appendimage $tempwavename2
		appendimage $targetname+"_ROI"	//S_name = name
		ModifyImage $targetname+"_ROI" minRGB=0,maxRGB=NaN
		ModifyImage $targetname+"_ROI" cindex=$colorwavename	//ctab= {*,0,Rainbow,0}
		TextBox /W=$s_name /A=MT "ROIs"
		AppendLayoutObject /W=$layoutname graph $s_name
	
	elseif (waveexists(threshold_base))
		if (headerexists &  g_HeaderInfo)
			setscale /p x 0,x_res,"m", threshold_base; delayupdate
			setscale /p y 0,y_res,"m", threshold_base; delayupdate
			setscale /p x 0,x_res,"m", $targetname+"_ROI"; delayupdate
			setscale /p y 0,y_res,"m", $targetname+"_ROI"; delayupdate
		endif
		Display /hide = 1; 
		appendimage threshold_base
		appendimage $targetname+"_ROI"	//S_name = name
		ModifyImage $targetname+"_ROI" minRGB=0,maxRGB=NaN
		ModifyImage $targetname+"_ROI" cindex=$colorwavename	//ctab= {*,0,Rainbow,0}
		TextBox /W=$s_name /A=MT "ROIs"
		AppendLayoutObject /W=$layoutname graph $s_name
		
	else
		print "No image for overlaying ROI (Auto Layout)"
	endif
	
	string poptarget = targetname+"_"
	string popresult=targetname+"_POP"
	populationwave(poptarget,popresult,roinumber)
	setscale /p y,0,1,"ROI #", $popresult; delayupdate
	if (headerexists & g_HeaderInfo)
		setscale /p x,0,z_res,"s", $popresult; delayupdate
	endif
	Display /k=1/hide = 1; 
	appendimage $popresult
	ColorScale/C/N=text3/A=RC /E lblRot=180;DelayUpdate
	ColorScale/C/N=text3 "F/F"
	setaxis /w=$s_name /A/R left
	AppendLayoutObject /W=$layoutname graph $s_name
	
	
	
	Do
		if (headerexists & g_HeaderInfo)
			setscale /p x,0,z_res,"s", $targetname+"_"+num2str(counter); delayupdate
		endif
		Display /k=1/hide = 1 $targetname+"_"+num2str(counter);delayupdate	//S_name = name
		ModifyGraph rgb =(0,0,0)
		graphname = s_name
			
		
		
		if(g_deltafbyf)
			Label left "F/F"
			else
			label left "Fluorescence (A.U.)"
		endif
		
		
		TextBox /W=$graphname /A=RT  /b=(tempcolorwave[counter+1][0],tempcolorwave[counter+1][1],tempcolorwave[counter+1][2]) "ROI #"+num2str(counter)
		
		
		
		if (mod(counter2, 6) > 0)
			AppendLayoutObject /W=$layoutname graph $graphname
		elseif (mod(counter2, 6) == 0)
			DoWindow /F $layoutname
			Execute /Q/Z "Tile /A=(3,2)"
			dowindow /hide=1 $layoutname
			NewLayout  /k=1/p=landscape /n=$targetname+"_Layout"+num2str(layoutnumber)	//S_name = name
			layoutname = s_name
			AppendLayoutObject /W=$layoutname graph $graphname
			layoutnumber +=1
		else
		print "This shouldn't happen (Auto Layout / naming)"
		endif
		
		
	
		counter2 +=1
		
		counter +=1
	while (counter < roinumber)
	
	DoWindow /F $layoutname
	Execute /Q/Z "Tile /A=(3,2)"
	dowindow /hide=1 $layoutname
	
	//------------------------Notebook-----------------------
	string notebookname
	variable theendisnigh = 0
		counter = 0
		do
			if (!(counter))
				notebookname = "Summary_"+nameofwave(imagestack)
			else
				notebookname = "Summary_"+nameofwave(imagestack)+num2str(counter)
			endif
			
			if (wintype(notebookname))
				counter +=1
			else
				theendisnigh = 1
			endif
		
		while (!(theendisnigh))
	

	NewNotebook /f=1 /n=$(notebookname) as nameofwave(imagestack)+"_summary"
	Notebook $(notebookname), fsize = 11, fstyle = 0, textrgb=(65535,65535,65535)
	
	Notebook $(notebookname), text="Summary for: "
	Notebook $(notebookname), fsize = 11, fstyle = 1, textrgb=(65535,65535,65535)
	Notebook $(notebookname), text=nameofwave(imagestack)+"\r", fstyle=1
	Notebook $(notebookname), fsize = 11, fstyle = 0, textrgb=(65535,65535,65535)
	Notebook $(notebookname), text="Date: "+expdate	+"\r"
	Notebook $(notebookname), text="Filename: "+filename	+"\r"

	
	
	if (g_HeaderInfo)		//read Header Info
		//	Notebook $(notebookname), text=+"\r"			//<---- for copy/paste

		Notebook $(notebookname), text="Zoom: \t"+num2str(zoom)+"\r"
		
		if (x_res >= 1)
			Notebook $(notebookname), text="X resolution: \t"+num2str(x_res)+" m per pixel"+"\r"
		else
			Notebook $(notebookname), text="X resolution: \t"+num2str(x_res*1000)+" nm per pixel"+"\r"
		endif
		if (y_res>1)
			Notebook $(notebookname), text="Y resolution: \t"+num2str(y_res)+" m per pixel"+"\r"
		else
			Notebook $(notebookname), text="Y resolution: \t"+num2str(y_res*1000)+" nm per pixel"+"\r"
		endif
		
		Notebook $(notebookname), text=num2str(timeperline)+" ms per line"+"\r"
		Notebook $(notebookname), text="Framerate: "+num2str(1/z_res)+" Hz"+"\r"
		Notebook $(notebookname), text="1 frame every "+num2str(1000*z_res)+" ms"	+"\r"
		Notebook $(notebookname), text="Age of test subject: "+age	+"\r"
		Notebook $(notebookname), text="Construct: "+construct	+"\r"
		Notebook $(notebookname), text="Settings: "+settings	+"\r"
		Notebook $(notebookname), text="Notes: "	+"\r"
	endif
	
	
	counter = 1
	Notebook $(notebookname), text= "-----------------------------------------------------------------------------------------------------------------\r"
	Notebook $(notebookname), text= "\r"	
	Notebook $(notebookname), scaling = {58,60}, picture={$targetname+"_Layout", 1,1}
	//dowindow /hide=1 $targetname+"_Layout"
	do
		
			
		Notebook $(notebookname), scaling={58,60}, picture={$targetname+"_Layout"+num2str(counter), 1,1}
		
		//dowindow /hide = 1 $targetname+"_Layout"+num2str(counter)
		counter +=1
	while (counter < layoutnumber) 
	
	
	
	
	
	
endif


g_QAStatus = "Finished. Generated "+Num2Str(roinumber)+" Traces"
killwaves /z Threshold_Base, Thresholded_Wave, M_ROIMask, headcalcwave, stringheadwave, tempcolorwave, m_colors
return roinumber

end