#pragma rtGlobals=1		// Use modern global access method.
#include "z-project"
#include "normalize"
#include "multiroi"
#include "M_Threshold"

Function QuickAnalysis(ImageStack)
wave ImageStack
variable xdim, ydim
variable /g ThresholdLevelNumber

string /g QAMethodType //"Average;SD;Raw Image"



strswitch(QAMethodType)
Case "Average":
avgZ(ImageStack, "Threshold_Base")
break

Case "SD":
stdevZ(ImageStack, "Threshold_Base")
break

Case "Raw Image":
xdim = dimsize(ImageStack, 0)
ydim = dimsize(ImageStack, 1)
Duplicate /o ImageStack, Threshold_Base  
Redimension /N=(xdim,ydim) Threshold_Base 
break

default:
Print "Default Case, using Average"
avgZ(ImageStack, "Threshold_Base")
break
endswitch

wave Threshold_Base

M_Threshold(Threshold_Base, "Thresholded_Wave", ThresholdLevelNumber)

wave Thresholded_Wave

thresh2roi(Thresholded_Wave,"M_ROIMask")

wave M_ROIMask

MultiROIZstack(Imagestack, "QuickAnalysis")


end