#pragma rtGlobals=1		// Use modern global access method.

Menu "Macros"
	"Read Header", ReadHeader()
	"Read Header - Safe", ReadHeader("HeaderWave")


End


Function ReadHeader([StrWaveName])		//Reads Header of a ScanImage Tif file
String StrWaveName

variable FileRefNum, FilePos = 0, Condition = 1, counter = 0
String Line

Open /R /M="Select a ScanImage .tif file." /T=".tif" FileRefNum as "ImageFile"
FStatus FileRefNum

if (!(V_Flag))		//Abort if cancelled
	return -1
endif

If (paramisdefault(StrWaveName))
	Variable PointPos
	PointPos = strsearch(S_Filename, ".tif", 0)
	StrWaveName = S_FileName[0,PointPos-1]
endif	



Do			//Find start of information

fSetPos FileRefNum, FilePos
fReadLine /T=(num2char(13)) FileRefNum, Line
	
	If (FilePos >= V_logEOF)
		DoAlert 0, "No occurence of a ScanImage header found in file <"+S_FileName+">."
		Return -1
	Elseif (stringmatch(Line[0,4], "state"))
		Condition = 0
	Else
		Condition = 1
	Endif
	

FilePos +=1
While (Condition)

Make /t/o/n=(150) Stringwave

filepos -=1
Condition = 1
Do			//Read header info

	fSetPos FileRefNum, FilePos
	fReadLine /T=(num2char(13)) FileRefNum, Line
	
	Stringwave[counter] = Line

	If (FilePos >= V_logEOF)
		Condition = 0
	Elseif (stringmatch(Line[0,4], "state") != 1)
		Condition = 0
	Elseif (counter > 150)
		DoAlert 0, "Found more Lines than StringWave has points. Readjust Function!"
		Condition = 0
	Endif

Counter +=1
FilePos += strlen(Line)
While (Condition)




Close FileRefNum

Redimension /n=(counter-1) StringWave
Duplicate /t/o Stringwave, $StrWaveName
Killwaves /z StringWave


Return Counter -1
End