#pragma rtGlobals=1		// Use modern global access method.

//  Fitted coefficient values
//	z0    	=10.889  0.00229
//  	A     	=49.834  0.0589
//  	x0    	=7.9411e-06  6.04e-10
//  	xWidth	=5.1084e-07  6.06e-10
//  	y0    	=8.6802e-06  6e-10
//  	yWidth	=5.0714e-07  6.02e-10
//  	cor   	=-0.028344  0.00167


Function Make2DGaussKernel(cor,xw,yw,image)
	Variable cor, xw, yw
	Wave Image
	
	Duplicate/o image, kernel 

	kernel=exp(-1/(2*(1-cor^2))*((x/xw)^2+(y/yw)^2-(2*cor*x*y)/(xw*yw)))


End

///////////////////////////////////////////

Function/Wave ImageDeconvolve(Image, Kernel)
	Wave Image, Kernel

	FFT/OUT=1/DEST=kernel_FFT kernel
	FFT/OUT=1/DEST=Image_FFT Image
	
	Wave/c kernel_FFT, Image_FFT
	
	Duplicate/o/free Image_FFT Decon_FFT
	
	MatrixOP/o Decon_FFT=Decon_FFT/Kernel_FFT
	
	IFFT /dest=Decon Decon_FFT
	
	
	Return Decon
End