#pragma rtGlobals=1		// Use modern global access method.
#include "inellipse"
#include "equalizescaling"


function mk()

wave kernel
kernel = 0
variable xc, yc, ie, int

for(xc=0;xc<400;xc+=1)
	for(yc=0;yc<400;yc+=1)
		
		ie = inellipse(xc,yc,20,20,6,6)
		if (ie > 0)
			kernel[xc][yc] = ie^(4)

		endif
	endfor
endfor

wavestats /Q kernel
int = v_sum
kernel /= int


end

//////////////////////////////////

function makekernel(image,diameter,[power])	//diameter in same units as image, i.e. m
wave image
variable diameter, power

variable dx, dy, xrad, yrad

if (paramisdefault(power))
	power = 4
endif

duplicate /o image, kernel
redimension /d kernel
fastop kernel = 0
dx = dimdelta(image, 0)
dy = dimdelta(image, 1)

xrad = diameter / (2*dx)
yrad = diameter/ (2*dy)

variable xc, yc, ie, int

for(xc=0;xc<xrad*2+2;xc+=1)
	for(yc=0;yc<yrad*2+2;yc+=1)
		
		ie = inellipse(xc,yc,0+xrad/2,0+yrad/2,xrad,yrad)	//inellipse(pointx, pointy, xcenter, ycenter, xradius, yradius)
		if (ie > 0)
			kernel[xc][yc] = ie^power

		endif
	endfor
endfor

wavestats /Q kernel
int = v_sum
kernel /= int

end


//////////////////////////////////

function makekernel_c(image,diameter,[power])	//diameter in same units as image, i.e. m
wave image
variable diameter, power

variable dx, dy, xrad, yrad

if (paramisdefault(power))
	power = 4
endif

duplicate /o image, kernel
redimension /d kernel
fastop kernel = 0
dx = dimdelta(image, 0)
dy = dimdelta(image, 1)

xrad = diameter / (2*dx)
yrad = diameter/ (2*dy)

variable xc, yc, ie, int

for(xc=0;xc<xrad*2+2;xc+=1)
	for(yc=0;yc<yrad*2+2;yc+=1)
		
		ie = inellipse(xc,yc,0+xrad/2,0+yrad/2,xrad,yrad)	//inellipse(pointx, pointy, xcenter, ycenter, xradius, yradius)
		if ((ie >= 0) && (ie < 0.1)) 
			kernel[xc][yc] = 1

		endif
	endfor
endfor

wavestats /Q kernel
int = v_sum
//kernel /= int

end


//////////////////////////////////

function deconvolve(image, diameter, pow)
wave image
variable diameter, pow

makekernel(image,diameter, power=pow)
wave kernel


fft /dest= kernel_fft kernel
fft /dest= image_fft image

matrixop /c/o result = image_fft / kernel_fft


ifft /dest= result_ifft result
result_ifft = sqrt(result_ifft ^2)
copyscaling(image,result_ifft)

end